<?PHP
/* ****************************************************
   simple cms
   by: Matt Pierce - 2009
   
   /simple_cms/edit_user.php
   
   Allows an administrator to edit a user's account
   or allows a user to edit his/her own account. The
   user must be an administrator to change permission
   settings or change group membership.
   **************************************************** */
include_once("../include/global.php");
session_start();
if (!session_is_registered('username')) {
	header("Location: login.php?RedirectTo=".basename($PHP_SELF));
} else {
	$username = $_SESSION['username'];
}

db_connect_a($MYSQL_DBName);
$UserResponse = mysql_query("SELECT * FROM users WHERE UserName='$username'");
$UserObj = mysql_fetch_object($UserResponse);
$UserID = $UserObj->UserID;

import_request_variables("p", "p");
import_request_variables("g", "g");

$AdminTitle = "users administration";
$AdminHeaderContent = "";
$AdminContent = "";
$AdminSection = "users";

ob_start();

if ($pUpdate && $pUpdate=="Update") {
	$UserResponse = mysql_query("SELECT * FROM users WHERE UserID=$pUserID");
	$UserObj = mysql_fetch_object($UserResponse);
	
	if ((UserIsAdmin($UserID) || $UserID==$pUserID) && $UserObj->UserName!="guest") {
		$uid = $pUserID;
		$pUserName = fix_apos($pUserName);
		$pUserFullName = fix_apos($pUserFullName);
		$pUserPhone = fix_apos($pUserPhone);
		$pUserEmail = fix_apos($pUserEmail);
		$pUserOffice = fix_apos($pUserOffice);
		$pUserPassword = fix_apos($pUserPassword);
		if ($pUserName) mysql_query("UPDATE users SET UserName='$pUserName' WHERE UserID=$uid");
		if ($pUserFullName) mysql_query("UPDATE users SET UserFullName='$pUserFullName' WHERE UserID=$uid");
		else mysql_query("UPDATE users SET UserFullName=NULL WHERE UserID=$uid");
		if ($pUserPhone) mysql_query("UPDATE users SET UserPhone='$pUserPhone' WHERE UserID=$uid");
		else mysql_query("UPDATE users SET UserPhone=NULL WHERE UserID=$uid");
		if ($pUserEmail) mysql_query("UPDATE users SET UserEmail='$pUserEmail' WHERE UserID=$uid");
		else mysql_query("UPDATE users SET UserEmail=NULL WHERE UserID=$uid");
		if ($pUserOffice) mysql_query("UPDATE users SET UserOffice='$pUserOffice' WHERE UserID=$uid");
		else mysql_query("UPDATE users SET UserOffice=NULL WHERE UserID=$uid");
		if (UserIsAdmin($UserID)) {
			if ($pUserIsAdmin == "Y") mysql_query("UPDATE users SET UserIsAdmin='Y' WHERE UserID=$uid");
			else mysql_query("UPDATE users SET UserIsAdmin='N' WHERE UserID=$uid");
			$Permissions = 0;
			if ($pView == "Y") $Permissions = $Permissions | $P_VIEW;
			if ($pEdit == "Y") $Permissions = $Permissions | $P_EDIT;
			if ($pCreate == "Y") $Permissions = $Permissions | $P_CREATE;
			if ($pPublish == "Y") $Permissions = $Permissions | $P_PUBLISH;
			if ($pDelete == "Y") $Permissions = $Permissions | $P_DELETE;
			if ($pManage == "Y") $Permissions = $Permissions | $P_MANAGE;
			if ($pImages == "Y") $Permissions = $Permissions | $P_IMAGES;
			mysql_query("UPDATE users SET UserPermissions=$Permissions WHERE UserID=$uid");
		}
		LogWrite($UserID, "User", "Edited Account Settings for User $uid ($pUserName)");
	}

	header("Location: edit_user.php?UserID=$pUserID");
} else if ($gAction && $gAction=="MoveRight" && UserIsAdmin($UserID)) {
	// see if this is the "everybody" group
	$GroupObj = mysql_fetch_object(mysql_query("SELECT * FROM groups WHERE GroupID=$gGroupID"));
	if ($GroupObj->GroupName != "everybody") {
		mysql_query("DELETE FROM usersgroupslink WHERE UserID=$gUserID AND GroupID=$gGroupID");
		LogWrite($UserID, "Membership", "Removed User $gUserID from Group $gGroupID");
	}
	header("Location: edit_user.php?UserID=$gUserID");
} else if ($gAction && $gAction=="MoveLeft" && UserIsAdmin($UserID)) {
	mysql_query("INSERT INTO usersgroupslink (UserID, GroupID) VALUES ($gUserID, $gGroupID)");
	LogWrite($UserID, "Membership", "Added User $gUserID to Group $gGroupID");
	header("Location: edit_user.php?UserID=$gUserID");
} else {

if (!$gUserID) {
	echo ("There is no user specified.");
} else if ($gUserID == $UserID || UserIsAdmin($UserID)) {
	$UserResponse = mysql_query("SELECT * FROM users WHERE UserID=$gUserID");
	$UserObj = mysql_fetch_object($UserResponse);
	$UserObj->UserPermissions = intval($UserObj->UserPermissions);
?>

<table width="95%"  border="0" cellspacing="0" cellpadding="4">
  <tr valign="top">
    <td width="50%"><form action="edit_user.php" method="post" name="UserForm" id="UserForm">
      <table width="95%"  border="0" cellspacing="0" cellpadding="4">
        <tr valign="top">
          <td width="1%" nowrap>Username</td>
          <td width="99%"><input name="UserName" type="text" id="UserName" style="width: 95%" value="<?PHP echo $UserObj->UserName;?>"></td>
        </tr>
        <tr valign="top">
          <td width="1%" nowrap>Full Name </td>
          <td width="99%"><input name="UserFullName" type="text" id="UserFullName" style="width: 95%" value="<?PHP echo $UserObj->UserFullName;?>"></td>
        </tr>
        <tr valign="top">
          <td width="1%" nowrap>Phone</td>
          <td width="99%"><input name="UserPhone" type="text" id="UserPhone" style="width: 95%" value="<?PHP echo $UserObj->UserPhone;?>"></td>
        </tr>
        <tr valign="top">
          <td width="1%" nowrap>E-Mail</td>
          <td width="99%"><input name="UserEmail" type="text" id="UserEmail" style="width: 95%" value="<?PHP echo $UserObj->UserEmail;?>"></td>
        </tr>
        <tr valign="top">
          <td width="1%" nowrap>Office</td>
          <td width="99%"><input name="UserOffice" type="text" id="UserOffice" style="width: 95%" value="<?PHP echo $UserObj->UserOffice;?>"></td>
        </tr>
		<?PHP 
		if (UserIsAdmin($UserID)) {
		?>
        <tr valign="top">
          <td width="1%" nowrap>Permissions</td>
          <td width="99%">            <input name="View" type="checkbox" id="View" value="Y" <?PHP if (($UserObj->UserPermissions & $P_VIEW)>0) echo "checked";?>>
            View<br>
            <input name="Edit" type="checkbox" id="Edit" value="Y" <?PHP if (($UserObj->UserPermissions & $P_EDIT)>0) echo "checked";?>>
            Edit<br>
            <input name="Create" type="checkbox" id="Create" value="Y" <?PHP if (($UserObj->UserPermissions & $P_CREATE)>0) echo "checked";?>>
            Create<br>
            <input name="Publish" type="checkbox" id="Publish" value="Y" <?PHP if (($UserObj->UserPermissions & $P_PUBLISH)>0) echo "checked";?>>
            Publish<br>
            <input name="Delete" type="checkbox" id="Delete" value="Y" <?PHP if (($UserObj->UserPermissions & $P_DELETE)>0) echo "checked";?>>
            Delete<br>
            <input name="Manage" type="checkbox" id="Manage" value="Y" <?PHP if (($UserObj->UserPermissions & $P_MANAGE)>0) echo "checked";?>>
            Manage<br>
			<input name="Images" type="checkbox" id="Images" value="Y" <?PHP if (($UserObj->UserPermissions & $P_IMAGES)>0) echo "checked";?>>
            Image Editing</td>
        </tr>
        <tr valign="top">
          <td width="1%" nowrap>Administrator</td>
          <td width="99%"><input name="UserIsAdmin" type="radio" value="Y" <?PHP if ($UserObj->UserIsAdmin == "Y") echo "checked";?>>
            Yes 
              <input name="UserIsAdmin" type="radio" value="N" <?PHP if ($UserObj->UserIsAdmin == "N") echo "checked";?>>
            No </td>
        </tr>
		<?PHP
		} else {
		?>
		<tr valign="top">
          <td width="1%" nowrap>Permissions</td>
		  <td>
			<?PHP
			$PermissionsOut = null;
			if (($UserObj->UserPermissions & $P_VIEW)>0) $PermissionsOut[] = "View";
			if (($UserObj->UserPermissions & $P_EDIT)>0) $PermissionsOut[] = "Edit";
			if (($UserObj->UserPermissions & $P_CREATE)>0) $PermissionsOut[] = "Create";
			if (($UserObj->UserPermissions & $P_PUBLISH)>0) $PermissionsOut[] = "Publish";
			if (($UserObj->UserPermissions & $P_DELETE)>0) $PermissionsOut[] = "Delete";
			if (($UserObj->UserPermissions & $P_MANAGE)>0) $PermissionsOut[] = "Manage";
			if (($UserObj->UserPermissions & $P_IMAGES)>0) $PermissionsOut[] = "Images";
			if ($UserObj->UserIsAdmin=="Y") $PermissionsOut[] = "Administrator";
			if (is_array($PermissionsOut)) {
				echo ("<ul>\n");
				foreach ($PermissionsOut as $p) {
					echo ("<li>$p</li>\n");
				}
				echo ("</ul>\n");
			}
			?>
		  </td>
		</tr>
		<?PHP
		}
		?>
        <tr valign="top">
          <td width="1%" nowrap><input name="UserID" type="hidden" id="UserID" value="<?PHP echo $UserObj->UserID;?>"></td>
          <td width="99%"><input name="Update" type="submit" id="Update" value="Update"></td>
        </tr>
      </table>
    </form>      </td>
    <td width="25%"><strong>Group Membership: </strong><p><?PHP
		// $GroupResponse = mysql_query("SELECT * FROM groups WHERE EXISTS (SELECT * FROM usersgroupslink WHERE usersgroupslink.GroupID=groups.GroupID AND UserID=$gUserID) ORDER BY GroupName");
		$GroupResponse = mysql_query("SELECT DISTINCT groups.GroupID, GroupName FROM groups, usersgroupslink WHERE usersgroupslink.GroupID=groups.GroupID AND UserID=$gUserID ORDER BY GroupName");
		while ($GroupObj = mysql_fetch_object($GroupResponse)) {
			$GroupList[] = $GroupObj->GroupID;
			echo ("$GroupObj->GroupName <a href=\"edit_user.php?UserID=$gUserID&GroupID=$GroupObj->GroupID&Action=MoveRight\">&gt;&gt;</a><br>\n");
		}
	?></p></td>
    <td width="25%"><strong>Other Groups: </strong><p><?PHP
		// $GroupResponse = mysql_query("SELECT * FROM groups WHERE NOT EXISTS (SELECT * FROM usersgroupslink WHERE usersgroupslink.GroupID=groups.GroupID AND UserID=$gUserID) ORDER BY GroupName");
		if ($GroupList) {
			$GroupResponse = mysql_query("SELECT * FROM groups WHERE NOT FIND_IN_SET(GroupID, '".implode(",",$GroupList)."') ORDER BY GroupName");
		} else {
			$GroupResponse = mysql_query("SELECT * FROM groups ORDER BY GroupName");
		}
		while ($GroupObj = mysql_fetch_object($GroupResponse)) {
			echo ("<a href=\"edit_user.php?UserID=$gUserID&GroupID=$GroupObj->GroupID&Action=MoveLeft\">&lt;&lt;</a> $GroupObj->GroupName<br>\n");
		}
	?></p></td>
  </tr>
</table><?PHP
} else {
	$UserResponse = mysql_query("SELECT * FROM users WHERE UserID=$gUserID");
	if (!$UserResponse || mysql_num_rows($UserResponse)==0) {
		echo ("<p>ERROR: Unable to find the specified user.</p>");
	} else {
		$UserObj = mysql_fetch_object($UserResponse);
		echo("<p><i>You do not have sufficient permissions to edit this user's data.</i></p>\n");
		echo("<table width=\"100%\" cellpadding=\"4\" cellspacing=\"0\">");

		echo("<tr><td width=\"1%\" noWrap=\"noWrap\"><b>Username</b></td>");
		echo("<td width=\"99%\">".$UserObj->UserName."</td></tr>\n");

		echo("<tr><td width=\"1%\" noWrap=\"noWrap\"><b>Full Name</b></td>");
		echo("<td width=\"99%\">".$UserObj->UserFullName."</td></tr>\n");

		echo("<tr><td width=\"1%\" noWrap=\"noWrap\"><b>E-Mail</b></td>");
		echo("<td width=\"99%\"><a href=\"mailto:".$UserObj->UserEmail."\">".$UserObj->UserEmail."</a></td></tr>\n");

		echo("<tr><td width=\"1%\" noWrap=\"noWrap\"><b>Phone Number</b></td>");
		echo("<td width=\"99%\">".$UserObj->UserPhone."</td></tr>\n");

		echo("<tr><td width=\"1%\" noWrap=\"noWrap\"><b>Office</b></td>");
		echo("<td width=\"99%\">".$UserObj->UserOffice."</td></tr>\n");

		echo("</table>\n");
		
		if ($UserObj->UserIsAdmin=="Y") echo ("<p>This user is an administrator.</p>");
		
		$GroupResponse = mysql_query("SELECT * FROM usersgroupslink WHERE UserID=$gUserID");
		
		if ($GroupResponse && mysql_num_rows($GroupResponse)>0) {
			$GroupList = NULL;
			while($GroupObj = mysql_fetch_object($GroupResponse)) {
				$GroupList[] = $GroupObj->GroupID;
			}
			if ($GroupList) {
				$GroupList = implode(",", $GroupList);
				$GroupResponse = mysql_query("SELECT * FROM groups WHERE FIND_IN_SET(GroupID, '$GroupList') ORDER BY GroupName");
				if ($GroupResponse && mysql_num_rows($GroupResponse)>0) {
					echo("<p>This user is a member of the following groups:</p>\n<ul>\n");
					while($GroupObj = mysql_fetch_object($GroupResponse)) {
						echo("<li>".$GroupObj->GroupName."</li>\n");
					}
				}
			}
		}
	}
}
}

$AdminContent = ob_get_contents();
ob_end_clean();

include ("admin_template.php");
?>