<?PHP
/* ****************************************************
   simple cms
   by: Matt Pierce - 2009
   
   /simple_cms/move_folder.php
   
   Allows a user to move a folder in the images tab.
   The user must have the $P_IMAGES permission bit set.
   **************************************************** */
include_once("../include/global.php");
session_start();
if (!session_is_registered('username')) {
	header("Location: login.php?RedirectTo=".basename($PHP_SELF));
} else {
	$username = $_SESSION['username'];
}

db_connect_a($MYSQL_DBName);
$UserResponse = mysql_query("SELECT * FROM users WHERE UserName='$username'");
$UserObj = mysql_fetch_object($UserResponse);
$UserID = $UserObj->UserID;

import_request_variables("p", "p");
import_request_variables("g", "g");

$AdminTitle = "move folder";
$AdminHeaderContent = "";
$AdminContent = "";
$AdminSection = "images";

$GroupList = Array();
$GroupResponse = mysql_query("SELECT * FROM usersgroupslink WHERE UserID=".($UserObj->UserID));
if ($GroupResponse && mysql_num_rows($GroupResponse)>0) {
	while ($GroupObj = mysql_fetch_object($GroupResponse)) {
		$GroupList[] = $GroupObj->GroupID;
	}
}

function GenerateFolderOptions($ParentID, $Prefix, $Exception, $ParentPermissions=NULL)
{
	global $UserObj, $GroupList, $P_VIEW;
	if ($Exception == NULL) return NULL; // don't allow them to move the root directory
	if ($ParentID) $FolderResponse = mysql_query("SELECT * FROM imagefolders WHERE FolderParentID=$ParentID AND NOT (FolderID=$Exception) ORDER BY FolderName");
	else $FolderResponse = mysql_query("SELECT * FROM imagefolders WHERE FolderParentID IS NULL AND NOT (FolderID=$Exception) ORDER BY FolderName");
	if ($FolderResponse && mysql_num_rows($FolderResponse)>0) {
		while ($FolderObj = mysql_fetch_object($FolderResponse)) {
			// we have to list all folders that the user is allowed to view, even if
			// they aren't allowed to move folders there
			$SubFolderPerms = GetImageFolderPermissionsRecursive($FolderObj->FolderID, $UserObj->UserID, $GroupList, $ParentPermissions);
			if ($SubFolderPerms & $P_VIEW) {
				echo("<option value=\"$FolderObj->FolderID\">$Prefix $FolderObj->FolderName</option>\n");
				GenerateFolderOptions($FolderObj->FolderID, $Prefix."--", $Exception);
			}
		}
	}
}

ob_start();


if (UserIsAdmin($UserObj->UserID) || ($UserObj->UserPermissions & $P_IMAGES)) {
	if ($pMove && $pMove=="Move") {
		if ($pMoveTo) {
			$SrcFolderPermissions = GetImageFolderPermissionsRecursive($pFolderID, $UserObj->UserID, $GroupList);
			$pMoveTo = intval($pMoveTo);
			if ($pMoveTo == -1) {
				$pMoveTo = "NULL";
				$DstFolderPermissions = GetImageFolderPermissionsRecursive(NULL, $UserObj->UserID, $GroupList);
			} else {
				$DstFolderPermissions = GetImageFolderPermissionsRecursive($pMoveTo, $UserObj->UserID, $GroupList);
			}
			if ($SrcFolderPermissions & $DstFolderPermissions & $P_EDIT) {
				mysql_query("UPDATE imagefolders SET FolderParentID=$pMoveTo WHERE FolderID=$pFolderID");
				header("Location: tab_images.php".($pMoveTo=="NULL"?"":"?CurrentFolder=$pMoveTo"));
			} else {
				header("Location: tab_images.php?CurrentFolder=".$pFolderID);
			}
		} else {
			header("Location: tab_images.php");
		}
		exit();
	}


	if (!$gParentFolder) $gParentFolder=NULL;
	
	$FolderPermissions = GetImageFolderPermissionsRecursive($gFolderID, $UserObj->UserID, $GroupList);
	if ($FolderPermissions & $P_EDIT) {
?>
<form action="move_folder.php" method="post" name="MoveFolderForm" id="MoveFolderForm">
  <table width="95%"  border="0" cellspacing="0" cellpadding="0">
    <tr>
      <td width="1%" nowrap>Move To: </td>
      <td width="99%"><select name="MoveTo" id="MoveTo" style="width:100%">
		<option value="-1">Home</option>
		<?PHP GenerateFolderOptions(NULL, "--", $gFolderID); ?>
	  </select></td>
    </tr>
    <tr>
      <td><input type="hidden" name="FolderID" id="FolderID" value="<?PHP echo $gFolderID;?>">&nbsp;
      <td><input name="Move" type="submit" id="Move" value="Move"></td>
    </tr>
  </table>
</form>
<?PHP
	} else {
		echo ("<p>ERROR: You do not have permission to move this folder.</p>\n");
	}
} else {
	echo ("<p>ERROR: You do not have permission move image folders.</p>\n");
}

$AdminContent = ob_get_contents();
ob_end_clean();

include("admin_template.php");
?>
