<?PHP
/* ****************************************************
   simple cms
   by: Matt Pierce - 2009
   
   /simple_cms/new_image.php
   
   Allows a user to upload a new image in the image
   management tab.  The user must have the $P_IMAGES
   permission bit set.
   **************************************************** */
include_once("../include/global.php");
include_once("../include/stahni-bmp.php");
session_start();
if (!session_is_registered('username')) {
	header("Location: login.php?RedirectTo=".basename($PHP_SELF));
} else {
	$username = $_SESSION['username'];
}

db_connect_a($MYSQL_DBName);
$UserResponse = mysql_query("SELECT * FROM users WHERE UserName='$username'");
$UserObj = mysql_fetch_object($UserResponse);
$UserID = $UserObj->UserID;

import_request_variables("p", "p");
import_request_variables("g", "g");

$AdminTitle = "add an image";
$AdminHeaderContent = "";
$AdminContent = "";
$AdminSection = "images";

ob_start();

$GroupList = GetGroups($UserObj->UserID);

if ($pCreate && $pCreate=="Create") {

	// check folder permissions
	if (isset($pImageFolderID)) {
		$FolderPermissions = GetImageFolderpermissionsRecursive($pImageFolderID, $UserObj->UserID, $GroupList);
	} else {
		$FolderPermissions = GetImageFolderpermissionsRecursive(NULL, $UserObj->UserID, $GroupList);
	}
	
	if ($FolderPermissions & $P_CREATE) {
		// check file upload
		if(!isset($_FILES['myfile'])) {
			echo "Error! The expected file wasn't a part of the submitted form.<br>\n";
		} else if($_FILES['myfile']['error'] != UPLOAD_ERR_OK) {
			echo "Error! The file uploaded failed.<br>\n";
			echo "Error #".$_FILES['myfile']['error']."<br>\n";
		} else {
			// create mysql entry 
			$pImageName = fix_apos($pImageName);
			$RandNum = "".(rand()%100000).date("YmdHis");
			mysql_query("INSERT INTO images (ImageName, ImageFileName, ImageThumbnailName) VALUES ('$pImageName', '$RandNum', '')");
			$ImageObj = mysql_fetch_object(mysql_query("SELECT * FROM images WHERE ImageFileName='$RandNum'"));
			$ImageID = $ImageObj->ImageID;
			// get image info
			$ImageInformation = getimagesize($_FILES['myfile']['tmp_name']);
			$t = intval($ImageInformation[2]);
			if ($t == 1) $Ext = ".gif";
			else if ($t == 2) $Ext = ".jpg";
			else if ($t == 3) $Ext = ".png";
			else if ($t == 6) $Ext = ".bmp";
			else if ($t == 15) $Ext = ".wbm";
			else $t = -1;
			
			if ($t == -1) {
				mysql_query("DELETE FROM images WHERE ImageID=$ImageID");
				header("Location: tab_images.php");
			} else {
				// move image to image folder
				if(!move_uploaded_file($_FILES['myfile']['tmp_name'], 
				"../images/simple/".$ImageID.$Ext)) {
					echo "Error! Moving the uploaded file failed.<br>\n";
				}
				// create thumbnail image
				if ($t == 1) $ImageData = imagecreatefromgif("../images/simple/".$ImageID.$Ext);
				else if ($t == 2) $ImageData = imagecreatefromjpeg("../images/simple/".$ImageID.$Ext);
				else if ($t == 3) $ImageData = imagecreatefrompng("../images/simple/".$ImageID.$Ext);
				else if ($t == 6) $ImageData = imagecreatefrombmp("../images/simple/".$ImageID.$Ext);
				else if ($t == 15) $ImageData = imagecreatefromwbmp("../images/simple/".$ImageID.$Ext);
				$OrigWidth = imagesx($ImageData);
				$OrigHeight = imagesy($ImageData);
				if ($OrigWidth>$OrigHeight) {
					$Width = 32;
					$Height = $OrigHeight*32/$OrigWidth;
				} else {
					$Height = 32;
					$Width = $OrigWidth*32/$OrigHeight;
				}
				$ThumbnailImage = imagecreatetruecolor($Width, $Height);
				imagecopyresampled($ThumbnailImage, $ImageData, 0,0, 0,0, $Width, $Height, $OrigWidth, $OrigHeight);
				imagejpeg($ThumbnailImage, "../images/simple/thumbnails/".$ImageID.".jpg", 50);
				// put filenames into mysql entry
				mysql_query("UPDATE images SET ImageFileName='../images/simple/$ImageID$Ext' WHERE ImageID=$ImageID");
				mysql_query("UPDATE images SET ImageThumbnailName='../images/simple/thumbnails/$ImageID.jpg' WHERE ImageID=$ImageID");
				// put additional data into mysql entry
				if ($pImageCaption) $pImageCaption = fix_apos($pImageCaption);
				if ($pImageAlt) $pImageAlt = fix_apos($pImageAlt);
				if ($pImageFolderID) $pImageFolderID = intval($pImageFolderID);
				if ($pImageCaption) mysql_query("UPDATE images SET ImageCaption='$pImageCaption' WHERE ImageID=$ImageID");
				if ($pImageAlt) mysql_query("UPDATE images SET ImageAlt='$pImageAlt' WHERE ImageID=$ImageID");
				if ($pImageFolderID && trim($pImageFolderID)!="") mysql_query("UPDATE images SET ImageFolderID=".intval($pImageFolderID)." WHERE ImageID=$ImageID");
		
			}
			if ($pImageFolderID) header("Location: tab_images.php?CurrentFolder=".$pImageFolderID);
			else header("Location: tab_images.php");
			exit();
		}
	}
}

if (UserIsAdmin($UserObj->UserID) || ($UserObj->UserPermissions & $P_IMAGES)) {
	if (!$gImageFolderID) $gImageFolderID=NULL;
	$FolderPermissions = GetImageFolderpermissionsRecursive($gImageFolderID, $UserObj->UserID, $GroupList);
	
	if ($FolderPermissions & $P_CREATE) {
?>
<form action="new_image.php" method="post" enctype="multipart/form-data" name="ImageForm" id="ImageForm">
  <table width="95%"  border="0" cellspacing="0" cellpadding="0">
    <tr>
      <td width="1%" nowrap>File:</td>
      <td width="99%"><input type="file" name="myfile" style="width:100%"></td>
    </tr>
    <tr>
      <td nowrap>Image Name: </td>
      <td><input name="ImageName" type="text" id="ImageName" style="width: 100%"></td>
    </tr>
    <tr>
      <td nowrap>Caption:</td>
      <td><input name="ImageCaption" type="text" id="ImageCaption" style="width: 100%"></td>
    </tr>
    <tr>
      <td nowrap>AltText:</td>
      <td><input name="ImageAlt" type="text" id="ImageAlt" style="width: 100%"></td>
    </tr>
    <tr>
      <td><?PHP if ($gImageFolderID) echo ("<input name=\"ImageFolderID\" type=\"hidden\" id=\"ImageFolderID\" value=\"$gImageFolderID\">"); ?></td>
      <td><input name="Create" type="submit" id="Create" value="Create"></td>
    </tr>
  </table>
</form>
<?PHP
	} else {
		echo ("<p>ERROR: You do not have permission to add images to this folder.</p>\n");
	}
} else {
	echo ("<p>ERROR: You do not have permission to edit images.</p>\n");
}

$AdminContent = ob_get_contents();
ob_end_clean();

include("admin_template.php");
?>
