<?PHP
/* ****************************************************
   simple cms
   by: Matt Pierce - 2009
   
   /simple_cms/revisions.php
   
   Allows a user to restore an older version of a page.
   The user must have the $P_MANAGE permission bit set.
   **************************************************** */
include_once("../include/global.php");
session_start();
if (!session_is_registered('username')) {
	header("Location: login.php?RedirectTo=".basename($PHP_SELF));
} else {
	$username = $_SESSION['username'];
}

db_connect_a($MYSQL_DBName);
$UserResponse = mysql_query("SELECT * FROM users WHERE UserName='$username'");
$UserObj = mysql_fetch_object($UserResponse);
$UserID = $UserObj->UserID;

import_request_variables("p", "p");
import_request_variables("g", "g");

$AdminTitle = "revisions";
$AdminHeaderContent = "";
$AdminContent = "";
$AdminSection = "pages";

if ($pRestore && $pRestore=="Restore") {
	$RevisionObj = mysql_fetch_object(mysql_query("SELECT * FROM revisions WHERE RevisionID=$pRevisionID"));
	$pid = $RevisionObj->PageID;
	if ((GetPagePermissions($pid, $UserID) & $P_MANAGE)>0) {
		// first, if an entry in pages exists, move it to the revisions table
		$RevisionResponse = mysql_query("SELECT * FROM pages WHERE PageID=$pid");
		if ($RevisionResponse && mysql_num_rows($RevisionResponse)>0) {
			$Rev = mysql_fetch_object($RevisionResponse);
			$Rev->PageTitle = fix_apos($Rev->PageTitle);
			$Rev->PageModifiedOn = fix_apos($Rev->PageModifiedOn);
			$Rev->PageMenuTitle = fix_apos($Rev->PageMenuTitle);
			$Rev->PageBody = fix_apos($Rev->PageBody);
			$Rev->PageStartDate = fix_apos($Rev->PageStartDate);
			$Rev->PageEndDate = fix_apos($Rev->PageEndDate);
			if ($Rev->PageFileName) $Rev->PageFileName = fix_apos($Rev->PageFileName);
			$Ins = "INSERT INTO revisions (PageID, PageTitle, PageKeywords, PageTemplateID, PageParentID, PageStartDate, PageEndDate, PageModifiedBy, PageModifiedOn, PageMenuOrder, PageMenuTitle, PageBody, PageRedirect, PageFileName) VALUES (";
			$Ins .= "$Rev->PageID, ";
			$Ins .= "'$Rev->PageTitle', ";
			$Ins .= ($Rev->PageKeywords?"'$Rev->PageKeywords', ":"NULL ,");
			$Ins .= ($Rev->PageTemplateID?"$Rev->PageTemplateID, ":"NULL, ");
			$Ins .= ($Rev->PageParentID?"$Rev->PageParentID, ":"NULL, ");
			$Ins .= ($Rev->PageStartDate?"'$Rev->PageStartDate', ":"NULL, ");
			$Ins .= ($Rev->PageEndDate?"'$Rev->PageEndDate', ":"NULL, ");
			$Ins .= "'$Rev->PageModifiedBy', ";
			$Ins .= "'$Rev->PageModifiedOn', ";
			$Ins .= "$Rev->PageMenuOrder, ";
			$Ins .= "'$Rev->PageMenuTitle', ";
			$Ins .= ($Rev->PageBody?"'$Rev->PageBody', ":"NULL, ");
			$Ins .= ($Rev->PageRedirect?"'$Rev->PageRedirect', ":"NULL, ");
			$Ins .= ($Rev->PageFileName?"'$Rev->PageFileName')":"NULL)");
			mysql_query($Ins);
		}
		// next, kill any drafts
		mysql_query("DELETE FROM drafts WHERE PageID=$pid");

		// last, put this revision up as the current page
		$RevisionResponse = mysql_query("SELECT * FROM revisions WHERE RevisionID=$pRevisionID");
		if ($RevisionResponse && mysql_num_rows($RevisionResponse)>0) {
			$Rev = mysql_fetch_object($RevisionResponse);
			$Rev->PageTitle = fix_apos($Rev->PageTitle);
			$Rev->PageModifiedOn = fix_apos($Rev->PageModifiedOn);
			$Rev->PageMenuTitle = fix_apos($Rev->PageMenuTitle);
			$Rev->PageBody = fix_apos($Rev->PageBody);
			$Rev->PageStartDate = fix_apos($Rev->PageStartDate);
			$Rev->PageEndDate = fix_apos($Rev->PageEndDate);
			if ($Rev->PageTitle) mysql_query("UPDATE pages SET PageTitle='$Rev->PageTitle' WHERE PageID=$Rev->PageID");
			else mysql_query("UPDATE pages SET PageTitle='' WHERE PageID=$Rev->PageID");
			if ($Rev->PageKeywords) mysql_query("UPDATE pages SET PageKeywords='$Rev->PageKeywords' WHERE PageID=$Rev->PageID");
			else mysql_query("UPDATE pages SET PageKeywords=NULL WHERE PageID=$Rev->PageID");
			if ($Rev->PageTemplateID) mysql_query("UPDATE pages SET PageTemplateID=$Rev->PageTemplateID WHERE PageID=$Rev->PageID");
			else mysql_query("UPDATE pages SET PageTemplateID=NULL WHERE PageID=$Rev->PageID");
			/*
			// it makes no sense to relocate the page when restoring a revision!
			if ($Rev->PageParentID)  mysql_query("UPDATE pages SET PageParentID=$Rev->PageParentID WHERE PageID=$Rev->PageID");
			else mysql_query("UPDATE pages SET PageParentID=NULL WHERE PageID=$Rev->PageID");
			*/
			if ($Rev->PageStartDate) mysql_query("UPDATE pages SET PageStartDate='$Rev->PageStartDate' WHERE PageID=$Rev->PageID");
			else mysql_query("UPDATE pages SET PageStartDate=NULL WHERE PageID=$Rev->PageID");
			if ($Rev->PageEndDate) mysql_query("UPDATE pages SET PageEndDate='$Rev->PageEndDate' WHERE PageID=$Rev->PageID");
			else mysql_query("UPDATE pages SET PageEndDate=NULL WHERE PageID=$Rev->PageID");
			mysql_query("UPDATE pages SET PageModifiedBy=$Rev->PageModifiedBy WHERE PageID=$Rev->PageID");
			mysql_query("UPDATE pages SET PageModifiedOn='$Rev->PageModifiedOn' WHERE PageID=$Rev->PageID");
			mysql_query("UPDATE pages SET PageMenuOrder=$Rev->PageMenuOrder WHERE PageID=$Rev->PageID");
			mysql_query("UPDATE pages SET PageMenuTitle='$Rev->PageMenuTitle' WHERE PageID=$Rev->PageID");
			if ($Rev->PageBody) mysql_query("UPDATE pages SET PageBody='$Rev->PageBody' WHERE PageID=$Rev->PageID");
			else mysql_query("UPDATE pages SET PageBody=NULL WHERE PageID=$Rev->PageID");
			if ($Rev->PageRedirect) mysql_query("UPDATE pages SET PageRedirect='$Rev->PageRedirect' WHERE PageID=$Rev->PageID");
			else mysql_query("UPDATE pages SET PageRedirect = NULL where PageID=$Rev->PageID");
			if ($Rev->PageMultiRoot) mysql_query("UPDATE pages SET PageMultiRoot=$Rev->PageMultiRoot WHERE PageID=$Rev->PageID");
			else mysql_query("UPDATE pages SET PageMultiRoot = NULL WHERE PageID=$Rev->PageID");
			if ($Rev->PageFileName) mysql_query("UPDATE pages SET PageFileName='".fix_apos($Rev->PageFileName)."' WHERE PageID=$Rev->PageID");
			else mysql_query("UDPATE pages SET PageFileName = NULL WHERE PageID=$Rev->PageID");
		}
		
		// update the rewrite map if necessary
		if (isset($MaintainAliasList) && $MaintainAliasList===true) {
			ExportAliasMap();
		}
		
		LogWrite($UserID, "Revision", "Reset Page $pid ($Rev->PageTitle) to Revision $pRevisionID ($Rev->PageModifiedBy, $Rev->PageModifiedOn)");
		
		// finally, render the static page to the webserver
		if (!Renderpage($pid)) {
			echo("ERROR: Unable to render page.");
		} else {
			header("Location: edit_page.php?PageID=".$pid);
		}

		header("Location: revisions.php?PageID=".$pid);
	} else {
		header("Location: tab_pages.php");
	}
} else if ($pDelete && $pDelete=="Delete") {
	$RevisionObj = mysql_fetch_object(mysql_query("SELECT * FROM revisions WHERE RevisionID=$pRevisionID"));
	$pid = $RevisionObj->PageID;
	if ((GetPagePermissions($pid, $UserID) & $P_MANAGE)>0) {
		mysql_query("DELETE FROM revisions WHERE RevisionID=".$pRevisionID);
		LogWrite($UserID, "Revision", "Deleted Revision $pRevisionID of Page $pid ($RevisionObj->PageTitle)");
		
		header("Location: revisions.php?PageID=".$pid);
	} else {
		header("Location: tab_pages.php");
	}
} else {

ob_start();
?>
	  <script>
		
		var ChildWindow = null;

		function CallPreview(PageID)
		{
			ChildWindow = window.open("preview_revision.php?RevisionID="+PageID, "ChildWindow", "width=1000, height=700, toolbar=0, status=0, scrollbars=yes");
		}
		</script>
<?PHP
$AdminHeaderContent = ob_get_contents();
ob_end_clean();

ob_start();

	if (!$gPageID) {
		echo("<p>ERROR: You must specify a page.</p>\n");
	} else {
		$Permissions = GetPagePermissions($gPageID, $UserID);
		if (($P_MANAGE & $Permissions) >0) {
			$RevisionRequest = mysql_query("SELECT * FROM revisions WHERE PageID=$gPageID ORDER BY PageModifiedOn DESC");
			while ($Rev = mysql_fetch_object($RevisionRequest)) {
				$UserResponse = mysql_query("SELECT * FROM users WHERE UserID=".$Rev->PageModifiedBy);
				if ($UserResponse && mysql_num_rows($UserResponse)>0) {
					$UserObj = mysql_fetch_object($UserResponse);
					$ModifiedBy = $UserObj->UserName;
				} else {
					$ModifiedBy = "Unknown or Deleted User";
				}
				$rid = $Rev->RevisionID;
			?>
<table width="95%"  border="0" cellspacing="0" cellpadding="4" style="border-bottom:1px solid #777777;">
              <tr>
                <td width="99%"><?PHP echo $Rev->PageTitle;?> - <?PHP echo $Rev->PageModifiedOn;?> - <?PHP echo $ModifiedBy?> - (<a href="javascript: CallPreview(<?PHP echo $rid;?>);">View</a>)</td>
                <td width="1%" nowrap><form action="revisions.php" method="post" name="RevForm<?PHP echo $rid;?>" id="RevForm<?PHP echo $rid;?>">
                  <input name="RevisionID" type="hidden" id="RevisionID" value="<?PHP echo $rid;?>">
                  <input name="Restore" type="submit" id="Restore" value="Restore">
                  <input name="Delete" type="submit" id="Delete" value="Delete">
                </form></td>
              </tr>
            </table>
<?PHP
			}
		} else {
			echo("<p>ERROR: You don't have permissions to manage this page's revisions.</p>\n");
		}
		echo("<p><a href=\"../pages/$gPageID.php\">Return to page</a></p>\n");
		
	}
	
$AdminContent = ob_get_contents();
ob_end_clean();
}

include ("admin_template.php");
?>