<?php 
/* ****************************************************
   simple cms
   by: Matt Pierce - 2009
   
   /include/global.php
   
   Contains some constants and functions that are
   available to all pages using the simple framework.
   **************************************************** */
	include_once("settings.php");
	if (!$DefaultEditMode) $DefaultEditMode = "xinha";
	if (!$PasswordHash) $PasswordHash = "THE QUICK BROWN FOX JUMPS OVER THE LAZY DOG the quick brown fox jumps over the lazy dog 0123456789";

// some global constants	
$PHP_SELF = $_SERVER['PHP_SELF'];
$P_VIEW = 1;
$P_EDIT = 2;
$P_CREATE = 4;
$P_PUBLISH = 8;
$P_DELETE = 16;
$P_MANAGE = 32;
$P_IMAGES = 64;
$P_ADMIN = 127;

function fix_apos($str)
{
	return addslashes($str);
}

function GetPasswordHashValue($Username, $Password)
{
	return md5($Username.$Password.$PasswordHash);
}

function db_connect ($DBName)
{
	// this is used just to read from the database
	global $MYSQL_Server, $MYSQL_UserName, $MYSQL_Password;

	$Link = @mysql_connect ($MYSQL_Server,$MYSQL_UserName,$MYSQL_Password);
	if ($Link && mysql_select_db ($DBName))
		return ($Link);
	return (FALSE);
}
function db_connect_a ($DBName)
{
	// This is used to make changes to the database
	global $MYSQL_Server, $MYSQL_AdminUserName, $MYSQL_AdminPassword;

	$Link = @mysql_connect ($MYSQL_Server,$MYSQL_AdminUserName,$MYSQL_AdminPassword);
	if ($Link && mysql_select_db ($DBName))
		return ($Link);
	return (FALSE);
}

function GetGroups($UserID) {
	$GroupList = Array();
	$GroupResponse = mysql_query("SELECT * FROM usersgroupslink WHERE UserID=".$UserID);
	if ($GroupResponse && mysql_num_rows($GroupResponse)>0) {
		while ($GroupObj = mysql_fetch_object($GroupResponse)) {
			$GroupList[] = $GroupObj->GroupID;
		}
	}
	return $GroupList;
}

function GroupIsAdmin($GroupID) {
	$GroupID = intval($GroupID);
	$GroupResponse = mysql_query("SELECT * FROM groups WHERE GroupID=$GroupID");
	if ($GroupResponse && mysql_num_rows($GroupResponse)>0) {
		$GroupObj = mysql_fetch_object($GroupResponse);
		return ($GroupObj->GroupIsAdmin=='Y'?true:false);
	} else {
		return false;
	}
}

function GetImageFolderGroupPermissionsRecursive($FolderID, $GroupID, $ParentPermissions=NULL)
{
	global $P_VIEW, $P_ADMIN;

	$Permissions = NULL;
	if ($FolderID == NULL) {
		$Permissions = NULL;
		if (GroupIsAdmin($GroupID)) {
			return $P_ADMIN;
		} else {
			return $P_VIEW;
		}
	}
	
	$GroupResponse = mysql_query("SELECT * FROM imagefoldergrouppermissions WHERE FolderID=$FolderID AND GroupID=$GroupID");
	if ($GroupResponse && mysql_num_rows($GroupResponse)>0) {
		$GroupObj = mysql_fetch_object($GroupResponse);
		return $GroupObj->Permissions;
	} else if ($ParentPermissions !== NULL) {
		return $ParentPermissions;
	} else {
		$FolderObj = mysql_fetch_object(mysql_query("SELECT * FROM imagefolders WHERE FolderID=$FolderID"));
		return GetImageFolderGroupPermissionsRecursive($FolderObj->FolderParentID, $GroupID);
	}
}

function GetImageFolderPermissionsRecursive($FolderID, $UserID, $GroupList, $ParentPermissions=NULL)
{
	global $P_VIEW, $P_ADMIN;
	
	if (UserIsAdmin($UserID)) return $P_ADMIN;
	
	$Permissions = NULL;
	if ($FolderID == NULL) {
		$Permissions = NULL;
		if (UserIsAdmin($UserID)) {
			return $P_ADMIN;
		} else {
			return $P_VIEW;
		}
	}

	$UserResponse = mysql_query("SELECT * FROM imagefolderuserpermissions WHERE FolderID=$FolderID AND UserID=$UserID");
	if ($UserResponse && mysql_num_rows($UserResponse)>0) {
		$UserObj = mysql_fetch_object($UserResponse);
		$Permissions = $UserObj->Permissions;
	} else if (is_array($GroupList) && count($GroupList)>0) {
		for ($x=0; $x<count($GroupList); $x++) {
			$gid = $GroupList[$x];
			$GroupResponse = mysql_query("SELECT * FROM imagefoldergrouppermissions WHERE FolderID=$FolderID AND GroupID=$gid");
			if ($GroupResponse && mysql_num_rows($GroupResponse)>0) {
				$GroupObj = mysql_fetch_object($GroupResponse);
				$Permissions = ($Permissions!==NULL?$Permissions:0) | $GroupObj->Permissions;
			}
		}
	}
	

	if ($Permissions === NULL) {
		if ($ParentPermissions === NULL) {
			$FolderObj = mysql_fetch_object(mysql_query("SELECT * FROM imagefolders WHERE FolderID=$FolderID"));
			return GetImageFolderPermissionsRecursive($FolderObj->FolderParentID, $UserID, $GroupList);
		} else {
			return $ParentPermissions;
		}
	} else {
		return $Permissions;
	}
}

function GetPermissionsRecursive($PageID, $UserID, $GroupList)
{
	global $P_VIEW;
	if ($PageID == NULL) return $P_VIEW; // everyone can see the home page
	
	$Permissions = NULL;
	$UserResponse = mysql_query("SELECT * FROM pageuserpermissions WHERE PageID=$PageID AND UserID=$UserID");
	if ($UserResponse && mysql_num_rows($UserResponse)>0) {
		$UserObj = mysql_fetch_object($UserResponse);
		$Permissions = $UserObj->Permissions;
	} else if (is_array($GroupList) && count($GroupList)>0) {
		for ($x=0; $x<count($GroupList); $x++) {
			$gid = $GroupList[$x];
			$GroupResponse = mysql_query("SELECT * FROM pagegrouppermissions WHERE PageID=$PageID AND GroupID=$gid");
			if ($GroupResponse && mysql_num_rows($GroupResponse)>0) {
				$GroupObj = mysql_fetch_object($GroupResponse);
				$Permissions = ($Permissions!==NULL?$Permissions:0) | $GroupObj->Permissions;
			}
		}
	}
	if ($Permissions === NULL) {
		$PageObj = mysql_fetch_object(mysql_query("SELECT * FROM pages WHERE PageID=$PageID"));
		return GetPermissionsRecursive($PageObj->PageParentID, $UserID, $GroupList);
	} else {
		return $Permissions;
	}
}

function GetPagePermissions($PageID, $UserID)
{
	global $P_ADMIN;
	$GroupList = NULL;
	
	$UserResponse = mysql_query("SELECT * FROM users WHERE UserID=$UserID");
	$UserObj = mysql_fetch_object($UserResponse);
	if ($UserObj->UserIsAdmin == "Y") {
		// echo("user admin");
		return $P_ADMIN;
	}
	
	// $GroupResponse = mysql_query("SELECT * FROM groups WHERE EXISTS (SELECT * FROM usersgroupslink WHERE UserID=$UserID AND usersgroupslink.GroupID=groups.GroupID)");
	$GroupResponse = mysql_query("SELECT DISTINCT groups.GroupID, groups.GroupIsAdmin FROM groups, usersgroupslink WHERE groups.GroupID=usersgroupslink.GroupID AND usersgroupslink.UserID=$UserID");
	if ($GroupResponse && mysql_num_rows($GroupResponse)>0) {
		while ($GroupObj = mysql_fetch_object($GroupResponse)) {
			if ($GroupObj->GroupIsAdmin=="Y") {
				// echo("group admin");
				return $P_ADMIN;
			}
			$GroupList[] = $GroupObj->GroupID;
		}
	}
	
	return $UserObj->UserPermissions & GetPermissionsRecursive($PageID, $UserID, $GroupList);
}
/*
function GetPermissionsRecursive($PageID, $UserID, $GroupID)
{
	global $P_VIEW;
	if ($PageID == NULL) return $P_VIEW;
	
	$UserResponse = mysql_query("SELECT * FROM pageuserpermissions WHERE PageID=$PageID AND UserID=$UserID");
	if ($GroupID) $GroupResponse = mysql_query("SELECT * FROM pagegrouppermissions WHERE PageID=$PageID AND GroupID=$GroupID");
	
	if (mysql_num_rows($UserResponse)>0) {
		$UserObj = mysql_fetch_object($UserResponse);
		return intval($UserObj->Permissions);
	} else if ($GroupID && mysql_num_rows($GroupResponse)>0) {
		$GroupObj = mysql_fetch_object($GroupResponse);
		return intval($GroupObj->Permissions);
	} else {
		$PageObj = mysql_fetch_object(mysql_query("SELECT * FROM pages WHERE PageID=$PageID"));
		return  GetPermissionsRecursive($PageObj->PageParentID, $UserID, $GroupID); 
	}
}

function GetPagePermissions($PageID, $UserID)
{
	global $P_ADMIN;
	$UserResponse = mysql_query("SELECT * FROM users WHERE UserID=$UserID");
	if (!$UserResponse || mysql_num_rows($UserResponse)==0) return 0;
	$UserObj = mysql_fetch_object($UserResponse);
	if ($UserObj->UserIsAdmin == "Y") return $P_ADMIN;

	$Permissions = GetPermissionsRecursive($PageID, $UserID, NULL);

	// $GroupResponse = mysql_query("SELECT * FROM groups WHERE EXISTS (SELECT * FROM usersgroupslink WHERE UserID=$UserID AND usersgroupslink.GroupID=groups.GroupID)");
	$GroupResponse = mysql_query("SELECT DISTINCT groups.GroupID, groups.GroupIsAdmin FROM groups, usersgroupslink WHERE groups.GroupID=usersgroupslink.GroupID AND usersgroupslink.UserID=$UserID");
	if ($GroupResponse && mysql_num_rows($GroupResponse)>0) {
		while($GroupObj = mysql_fetch_object($GroupResponse)) {
			if ($GroupObj->GroupIsAdmin == "Y") return $P_ADMIN;
			$Permissions = $Permissions | GetPermissionsRecursive($PageID, $UserID, $GroupObj->GroupID);
		}
	}
	return $Permissions  & $UserObj->UserPermissions;
}
*/

function GetGroupPermissionsRecursive($PageID, $GroupID)
{
	global $P_VIEW;
	if ($PageID == NULL) return $P_VIEW;
	$GroupResponse = mysql_query("SELECT * FROM pagegrouppermissions WHERE PageID=$PageID AND GroupID=$GroupID");

	if ($GroupID && mysql_num_rows($GroupResponse)>0) {
		$GroupObj = mysql_fetch_object($GroupResponse);
		return intval($GroupObj->Permissions);
	} else {
		$PageObj = mysql_fetch_object(mysql_query("SELECT * FROM pages WHERE PageID=$PageID"));
		return  GetGroupPermissionsRecursive($PageObj->PageParentID, $GroupID); 
	}
}

function GetGroupPermissions($PageID, $GroupID)
{
	global $P_ADMIN;
	$GroupObj = mysql_fetch_object(mysql_query("SELECT * FROM groups WHERE GroupID=$GroupID"));
	if ($GroupObj->GroupIsAdmin=="Y") return $P_ADMIN;
	else return GetGroupPermissionsRecursive($PageID, $GroupID);
}

function GetPermissionsSimple($PageID, $UserID, $GroupList, $Inherited)
{
	global $P_VIEW;
	if ($PageID == NULL) return $P_VIEW; // everyone can see the home page
	
	$Permissions = NULL;
	$UserResponse = mysql_query("SELECT * FROM pageuserpermissions WHERE PageID=$PageID AND UserID=$UserID");
	if ($UserResponse && mysql_num_rows($UserResponse)>0) {
		$UserObj = mysql_fetch_object($UserResponse);
		$Permissions = $UserObj->Permissions;
	} else if (is_array($GroupList) && count($GroupList)>0) {
		for ($x=0; $x<count($GroupList); $x++) {
			$gid = $GroupList[$x];
			$GroupResponse = mysql_query("SELECT * FROM pagegrouppermissions WHERE PageID=$PageID AND GroupID=$gid");
			if ($GroupResponse && mysql_num_rows($GroupResponse)>0) {
				$GroupObj = mysql_fetch_object($GroupResponse);
				$Permissions = ($Permissions===NULL?$Permissions:0) | $GroupObj->Permissions;
			}
		}
	}
	if ($Permissions === NULL) {
		$PageObj = mysql_fetch_object(mysql_query("SELECT * FROM pages WHERE PageID=$PageID"));
		return $Inherited;
	} else {
		return $Permissions;
	}
}

function GetPagePermissionsSimple($PageID, $UserID, $Inherited)
{
	global $P_ADMIN;
	$GroupList = NULL;
	
	$UserResponse = mysql_query("SELECT * FROM users WHERE UserID=$UserID");
	$UserObj = mysql_fetch_object($UserResponse);
	if ($UserObj->UserIsAdmin == "Y") return $P_ADMIN;
	
	// $GroupResponse = mysql_query("SELECT * FROM groups WHERE EXISTS (SELECT * FROM usersgroupslink WHERE UserID=$UserID AND usersgroupslink.GroupID=groups.GroupID)");
	$GroupResponse = mysql_query("SELECT DISTINCT groups.GroupID, groups.GroupIsAdmin FROM groups, usersgroupslink WHERE groups.GroupID=usersgroupslink.GroupID AND usersgroupslink.UserID=$UserID");
	if ($GroupResponse && mysql_num_rows($GroupResponse)>0) {
		while ($GroupObj = mysql_fetch_object($GroupResponse)) {
			if ($GroupObj->GroupIsAdmin=="Y") return $P_ADMIN;
			$GroupList[] = $GroupObj->GroupID;
		}
	}
	
	return $UserObj->UserPermissions &GetPermissionsSimple($PageID, $UserID, $GroupList, $Inherited);
}

/*
function GetPermissionsSimple($PageID, $UserID, $GroupID, $Inherited)
{
	global $P_VIEW;
	if ($PageID == NULL) return $P_VIEW;
	
	$UserResponse = mysql_query("SELECT * FROM pageuserpermissions WHERE PageID=$PageID AND UserID=$UserID");
	if ($GroupID) $GroupResponse = mysql_query("SELECT * FROM pagegrouppermissions WHERE PageID=$PageID AND GroupID=$GroupID");
	
	if (mysql_num_rows($UserResponse)>0) {
		$UserObj = mysql_fetch_object($UserResponse);
		return intval($UserObj->Permissions);
	} else if ($GroupResponse && mysql_num_rows($GroupResponse)>0) {
		$GroupObj = mysql_fetch_object($GroupResponse);
		return intval($GroupObj->Permissions);
	} else {
		return $Inherited; 
	}
}

function GetPagePermissionsSimple($PageID, $UserID, $Inherited)
{
	global $P_ADMIN;
	$UserResponse = mysql_query("SELECT * FROM users WHERE UserID=$UserID");
	if (!$UserResponse || mysql_num_rows($UserResponse)==0) return 0;
	$UserObj = mysql_fetch_object($UserResponse);
	if ($UserObj->UserIsAdmin == "Y") return $P_ADMIN;

	$Permissions = GetPermissionsSimple($PageID, $UserID, NULL, $Inherited);

	// $GroupResponse = mysql_query("SELECT * FROM groups WHERE EXISTS (SELECT * FROM usersgroupslink WHERE UserID=$UserID AND usersgroupslink.GroupID=groups.GroupID)");
	$GroupResponse = mysql_query("SELECT DISTINCT groups.GroupID, groups.GroupIsAdmin FROM groups, usersgroupslink WHERE groups.GroupID=usersgroupslink.GroupID AND usersgroupslink.UserID=$UserID");
	if ($GroupResponse && mysql_num_rows($GroupResponse)>0) {
		while($GroupObj = mysql_fetch_object($GroupResponse)) {
			if ($GroupObj->GroupIsAdmin == "Y") return $P_ADMIN;
			$Permissions = $Permissions | GetPermissionsSimple($PageID, $UserID, $GroupObj->GroupID, $Inherited);
		}
	}
	return $Permissions  & $UserObj->UserPermissions;
}
*/

function GetPageAlias($PageID) {
	$Alias = "";
	
	$PageResponse = mysql_query("SELECT * FROM pages WHERE PageID=".intval($PageID));
	if ($PageResponse && mysql_num_rows($PageResponse)>0) {
		while ($PageObj = mysql_fetch_object($PageResponse)) {
			if ($PageObj->PageParentID == NULL) {
				return "/".$Alias;
			} else if ($PageObj->PageFileName && trim($PageObj->PageFileName)!="") {
				$Alias = $PageObj->PageFileName.($Alias!=""?"/".$Alias:"");
				$PageResponse = mysql_query("SELECT * FROM pages WHERE PageID=".$PageObj->PageParentID);
			} else {
				return NULL;
			}
		}
	}
}

function OutputMultiContents($ParentID, $UserID, $AliasPrepend=NULL)
{
	global $P_VIEW, $MYSQL_DBName, $UseAliasesInLinks;
	db_connect($MYSQL_DBName);
	
	if (($AliasPrepend == NULL) && ($UseAliasesInLinks==true)) {
		// we don't know the alias prepend, so fetch it
		$AliasPrepend = GetPageAlias($ParentID);
	}
	
	$Now = date("Y-m-d H:i:s");
	$PageResponse = mysql_query("SELECT * FROM pages WHERE PageParentID=$ParentID AND (PageStartDate IS NULL OR PageStartDate<='$Now') AND (PageEndDate IS NULL OR PageEndDate>='$Now') AND PageMenuOrder>=0 ORDER BY PageMenuOrder, PageTitle");
	if ($PageResponse && mysql_num_rows($PageResponse)>0) {
		echo ("<ul>\n");
		while ($PageObj = mysql_fetch_object($PageResponse)) {
			$Permissions = GetPagePermissions($PageObj->PageID, $UserID);
			if (($Permissions & $P_VIEW) > 0) {
				echo ("<li>");
				if (($AliasPrepend!=NULL) && ($UseAliasesInLinks==true) && ($PageObj->PageFileName)) {
					$t_url = $AliasPrepend."/".$PageObj->PageFileName;
					echo ("<a href=\"".$t_url."\">".$PageObj->PageTitle."</a>");
					OutputMultiContents($PageObj->PageID, $UserID, $t_url);
				} else {
					echo ("<a href=\"/pages/$PageObj->PageID.php\">$PageObj->PageTitle</a>");
					OutputMultiContents($PageObj->PageID, $UserID);
				}
				echo ("</li>\n");
			}
		}
		echo ("</ul>\n");
	}
}

function RenderPage($PageID)
{
	global $MYSQL_DBName;
	$SiteFolder = str_replace($_SERVER['SCRIPT_NAME'], "", $_SERVER["SCRIPT_FILENAME"]);
	db_connect($MYSQL_DBName);
	$PageQuery = "SELECT * FROM pages WHERE PageID=$PageID";
	$PageResponse = mysql_query($PageQuery);
	if (!$PageResponse) return false;
	
	$PageObj = mysql_fetch_object($PageResponse);	
	
	$TemplateQuery = "SELECT * FROM templates WHERE TemplateID=".$PageObj->PageTemplateID;
	$TemplateResponse = mysql_query($TemplateQuery);
	if (!$TemplateResponse) return false;
	
	$TemplateObj = mysql_fetch_object($TemplateResponse);
	$TemplateFileName = $SiteFolder."/templates/".$TemplateObj->TemplateFile;
	$TemplateHandle = fopen($TemplateFileName, 'r');
	if (!$TemplateHandle) return false;
	$TemplateText = "";
	while (!feof($TemplateHandle)) {
		$TemplateText .= fgets($TemplateHandle, 1024);
	}
	fclose($TemplateHandle);
	
	$MultiRoot = $PageObj->PageMultiRoot;
	$PageBody = "";
	if ($MultiRoot) {
		if ($MultiRoot == $PageID) {
			$PageBody = "<h1>$PageObj->PageTitle</h1> <?PHP OutputMultiContents($MultiRoot, \$CurrentUserID);?>\n";
		} else {
			$PageBody = "<div class=\"SimpleMultiNav\"><?PHP GenerateNextLast($MultiRoot, \$CurrentPageID, \$CurrentUserID); ?></div>\n";
		}
	}
	$PageBody .= $PageObj->PageBody;
	
	$TemplateText = str_replace("<!-- SIMPLE PageTitle -->", $PageObj->PageTitle, $TemplateText);
	$TemplateText = str_replace("<!-- SIMPLE PageBody -->", $PageBody, $TemplateText);
	$TemplateText = "<?PHP
			\$CurrentPageID = ".$PageID.";
			include_once(\"../include/pagestart.php\");
			 ?>".$TemplateText;

	if ($PageObj->PageRedirect && ($PageObj->PageRedirect != "")) {
		$TemplateText = "<?PHP header(\"Location: ".$PageObj->PageRedirect."\");?>";
	}
	
	$OutputFilename = $SiteFolder."/pages/".$PageObj->PageID.".php";
	$OutputHandle = fopen($OutputFilename, 'w');
	if (!$OutputHandle) return false;
	fputs($OutputHandle, $TemplateText);
	fclose($OutputHandle);
	
	return true;
}

function TemplateUpdate($TemplateID)
{
	global $MYSQL_DBName;
	db_connect($MYSQL_DBName);
	$PageResponse = mysql_query("SELECT * FROM pages WHERE PageTemplateID=$TemplateID");
	if ($PageResponse && mysql_num_rows($PageResponse)) {
		while ($PageObj = mysql_fetch_object($PageResponse)) {
			RenderPage($PageObj->PageID);
		}
	}
}

function RenderDraftOrRevision($PageID, $PageQuery)
{
	global $MYSQL_DBName;
	db_connect($MYSQL_DBName);
	$PageResponse = mysql_query($PageQuery);
	if (!$PageResponse) return false;
	
	$PageObj = mysql_fetch_object($PageResponse);	
	
	$TemplateQuery = "SELECT * FROM templates WHERE TemplateID=".$PageObj->PageTemplateID;
	$TemplateResponse = mysql_query($TemplateQuery);
	if (!$TemplateResponse) return false;
	
	$TemplateObj = mysql_fetch_object($TemplateResponse);
	$TemplateFileName = "../templates/".$TemplateObj->TemplateFile;
	$TemplateHandle = fopen($TemplateFileName, 'r');
	if (!$TemplateHandle) return false;
	$TemplateText = "";
	while (!feof($TemplateHandle)) {
		$TemplateText .= fgets($TemplateHandle, 1024);
	}
	fclose($TemplateHandle);
	
	$MultiRoot = $PageObj->PageMultiRoot;
	$PageBody = "";
	if ($MultiRoot) {
		if ($MultiRoot == $PageID) {
			$PageBody = "<h1>$PageObj->PageTitle</h1> <?PHP OutputMultiContents($MultiRoot, \$CurrentUserID);?>\n";
		} else {
			$PageBody = "<div class=\"SimpleMultiNav\"><?PHP GenerateNextLast($MultiRoot, \$CurrentPageID, \$CurrentUserID); ?></div>\n";
		}
	}
	$PageBody .= $PageObj->PageBody;
	
	$TemplateText = str_replace("<!-- SIMPLE PageTitle -->", $PageObj->PageTitle, $TemplateText);
	$TemplateText = str_replace("<!-- SIMPLE PageBody -->", $PageBody, $TemplateText);
	$TemplateText = str_replace("<!-- SIMPLE PageKeywords -->", $PageObj->PageKeywords, $TemplateText);
	$TemplateText = "<?PHP
			\$CurrentPageID = ".$PageObj->PageID.";
			include_once(\"../include/pagestart.php\");
			 ?>".$TemplateText;
	
	$OutputFilename = "/tmp/".$PageID.".php";
	$OutputHandle = fopen($OutputFilename, 'w');
	if (!$OutputHandle) return false;
	fputs($OutputHandle, $TemplateText);
	fclose($OutputHandle);
	
	return true;
}

function RenderPreviewPage($PageID)
{
	return RenderDraftOrRevision($PageID, "SELECT * FROM drafts WHERE PageID=$PageID");
}

function RenderRevision($RevisionID)
{
	return RenderDraftOrRevision($RevisionID, "SELECT * FROM revisions WHERE RevisionID=$RevisionID");
}

function GetParentage($PageID)
{
	$CurrID = $PageID;
	while ($CurrID != NULL) {
		$Parentage[] = $CurrID;
		$PageResponse = mysql_query("SELECT * FROM pages WHERE PageID=".$CurrID);
		$PageObj = mysql_fetch_object($PageResponse);
		$CurrID = $PageObj->PageParentID;
	}

	return $Parentage;
}

function GenerateBreadcrumbs($PageID, $ParentID=NULL, $delimiter="&gt;")
{
	global $UseAliasesInLinks;
		
	$CurrID = $PageID;
	while ($CurrID != NULL) {
		$Parentage[]= $CurrID;
		$PageResponse = mysql_query("SELECT * FROM pages WHERE PageID=".$CurrID);
		$PageObj = mysql_fetch_object($PageResponse);
		$ParentageName[] = $PageObj->PageMenuTitle;
		if ($ParentID && $ParentID==$PageObj->PageID) {
			$CurrID = NULL;
		} else {
			$CurrID = $PageObj->PageParentID;
		}
	}
	
	$obuff = "";
	$delimiter = " $delimiter ";
	while(count($Parentage)>0) {
		$PageTitle = array_pop($ParentageName);
		$PageNumber = array_pop($Parentage);
		if ($UseAliasesInLinks) $t_url = GetPageAlias($PageNumber);
		else $t_url = "/pages/".$PageNumber.".php";
		$obuff .= ($obuff==""?"":$delimiter)."<a href=\"".$t_url."\">$PageTitle</a>";
	}
	echo "<div class=\"simple-breadcrumbs\">$obuff</div>";
}

function UserIsAdmin($UserID)
{
	$UserResponse = mysql_query("SELECT * FROM users WHERE UserID=$UserID");
	$UserObj = mysql_fetch_object($UserResponse);
	if ($UserObj->UserIsAdmin=="Y") return true;
	// $GroupResponse = mysql_query("SELECT * FROM groups WHERE EXISTS (SELECT * FROM usersgroupslink WHERE UserID=$UserID AND usersgroupslink.GroupID=groups.GroupID)");
	$GroupResponse = mysql_query("SELECT DISTINCT groups.GroupID, groups.GroupIsAdmin FROM groups, usersgroupslink WHERE groups.GroupID=usersgroupslink.GroupID AND usersgroupslink.UserID=$UserID");
	while ($GroupObj = mysql_fetch_object($GroupResponse)) {
		if ($GroupObj->GroupIsAdmin=="Y") return true;
	}
	return false;
}

function MenuChildrenGuest($Parentage, $CurrentID, $depth, $AliasPrepend=NULL)
{
	global $UseAliasesInLinks;

	if ($depth>0) {
		$ParentID = array_pop($Parentage);
		$MenuResponse = mysql_query("SELECT * FROM pages WHERE PageParentID=".$ParentID." AND PageMenuOrder>=0 AND ((PageStartDate<'".date("Y-m-d H:i:s")."') OR (PageStartDate IS NULL)) AND ((PageEndDate>'".date("Y-m-d H:i:s")."') OR (PageEndDate IS NULL)) ORDER BY PageMenuOrder, PageMenuTitle");
		if ($MenuResponse && mysql_num_rows($MenuResponse)>0) {
			if ($UseAliasesInLinks && ($AliasPrepend==NULL)) {
				$AliasPrepend = GetPageAlias($ParentID);
			}
			while ($MenuObj = mysql_fetch_object($MenuResponse)) {
				if ($MenuObj->PageGuestView) {
					if ($UseAliasesInLinks && $AliasPrepend && $MenuObj->PageFileName) {
						$t_url = ($AliasPrepend!="/"?$AliasPrepend:"")."/".$MenuObj->PageFileName;
						if ($CurrentID == $MenuObj->PageID) echo("<div class=\"MenuItem\"><a href=\"$t_url\"><b>".$MenuObj->PageMenuTitle."</b></a>");
						else echo("<div class=\"MenuItem\"><a href=\"$t_url\">".$MenuObj->PageMenuTitle."</a>");
						if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) MenuChildrenGuest($Parentage, $CurrentID, $depth-1, $t_url);
					} else {
						if ($CurrentID == $MenuObj->PageID) echo("<div class=\"MenuItem\"><a href=\"/pages/".$MenuObj->PageID.".php\"><b>".$MenuObj->PageMenuTitle."</b></a>");
						else echo("<div class=\"MenuItem\"><a href=\"/pages/".$MenuObj->PageID.".php\">".$MenuObj->PageMenuTitle."</a>");
						if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) MenuChildrenGuest($Parentage, $CurrentID, $depth-1);
					}
					echo("</div>\n");
				}
			}
		}
	}
}

function MenuChildren($Parentage, $UserID, $CurrentID, $Inherited, $depth, $AliasPrepend = NULL)
{
	global $P_VIEW, $P_ADMIN, $UseAliasesInLinks;
	
	if ($depth>0) {
		$ParentID = array_pop($Parentage);
		$MenuResponse = mysql_query("SELECT * FROM pages WHERE PageParentID=".$ParentID." AND PageMenuOrder>=0 AND ((PageStartDate<'".date("Y-m-d H:i:s")."') OR (PageStartDate IS NULL)) AND ((PageEndDate>'".date("Y-m-d H:i:s")."') OR (PageEndDate IS NULL)) ORDER BY PageMenuOrder, PageMenuTitle");
		if ($MenuResponse && mysql_num_rows($MenuResponse)>0) {
			if ($UseAliasesInLinks && ($AliasPrepend==NULL)) {
				$AliasPrepend = GetPageAlias($ParentID);
			}
			while ($MenuObj = mysql_fetch_object($MenuResponse)) {
				$Permissions = intval(GetPagePermissionsSimple($MenuObj->PageID, $UserID, $Inherited));
				// $Permissions = intval(GetPagePermissions($MenuObj->PageID, $UserID));
				if (($Permissions & $P_VIEW)!=0) {
					if ($UseAliasesInLinks && $AliasPrepend && $MenuObj->PageFileName) {
						$t_url = ($AliasPrepend!="/"?$AliasPrepend:"")."/".$MenuObj->PageFileName;
						if ($CurrentID == $MenuObj->PageID) echo("<div class=\"MenuItem\"><a href=\"$t_url\"><b>".$MenuObj->PageMenuTitle."</b></a>");
						else echo("<div class=\"MenuItem\"><a href=\"$t_url\">".$MenuObj->PageMenuTitle."</a>");
						if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) MenuChildren($Parentage, $UserID, $CurrentID, $Permissions, $depth-1, $t_url);
					} else {
						if ($CurrentID == $MenuObj->PageID) echo("<div class=\"MenuItem\"><a href=\"/pages/".$MenuObj->PageID.".php\"><b>".$MenuObj->PageMenuTitle."</b></a>");
						else echo("<div class=\"MenuItem\"><a href=\"/pages/".$MenuObj->PageID.".php\">".$MenuObj->PageMenuTitle."</a>");
						if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) MenuChildren($Parentage, $UserID, $CurrentID, $Permissions, $depth-1);
					}
					echo("</div>\n");
				}
			}
		}
	}
}

function MenuChildrenGuestUL($Parentage, $CurrentID, $depth, $AliasPrepend=NULL)
{
	global $UseAliasesInLinks;
	$output_cache = "";
	
	if ($depth>0) {
		$ParentID = array_pop($Parentage);
		$MenuResponse = mysql_query("SELECT * FROM pages WHERE PageParentID=".$ParentID." AND PageMenuOrder>=0 AND ((PageStartDate<'".date("Y-m-d H:i:s")."') OR (PageStartDate IS NULL)) AND ((PageEndDate>'".date("Y-m-d H:i:s")."') OR (PageEndDate IS NULL)) ORDER BY PageMenuOrder, PageMenuTitle");
		if ($MenuResponse && mysql_num_rows($MenuResponse)>0) {
			if ($UseAliasesInLinks && ($AliasPrepend==NULL)) {
				$AliasPrepend = GetPageAlias($ParentID);
			}
			while ($MenuObj = mysql_fetch_object($MenuResponse)) {
				if ($MenuObj->PageGuestView) {
					if ($UseAliasesInLinks && $MenuObj->PageFileName && $AliasPrepend) {
						$t_url = ($AliasPrepend!="/"?$AliasPrepend:"")."/".$MenuObj->PageFileName;
						if ($CurrentID == $MenuObj->PageID) $output_cache .= "<li class=\"MenuCurrentPage\"><a href=\"$t_url\">".$MenuObj->PageMenuTitle."</a>";
						else $output_cache .= "<li><a href=\"$t_url\">".$MenuObj->PageMenuTitle."</a>";
						if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) $output_cache .= MenuChildrenGuestUL($Parentage, $CurrentID, $depth-1, $t_url);
					} else {
						if ($CurrentID == $MenuObj->PageID) $output_cache .= "<li class=\"MenuCurrentPage\"><a href=\"/pages/".$MenuObj->PageID.".php\">".$MenuObj->PageMenuTitle."</a>";
						else $output_cache .= "<li><a href=\"/pages/".$MenuObj->PageID.".php\">".$MenuObj->PageMenuTitle."</a>";
						if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) $output_cache .= MenuChildrenGuestUL($Parentage, $CurrentID, $depth-1);
					}
					$output_cache .= "</li>\n";
				}
			}
		} else {
			$e = mysql_error();
		}
		if ($output_cache != "") return "<ul>\n".$output_cache."</ul>\n";
		else return "";
	} else {
		return "";
	}
}

function MenuChildrenUL($Parentage, $UserID, $CurrentID, $Inherited, $depth, $AliasPrepend=NULL)
{
	global $P_VIEW, $P_ADMIN, $UseAliasesInLinks;
	$output_cache = "";
	
	if ($depth>0) {
		$ParentID = array_pop($Parentage);
		$MenuResponse = mysql_query("SELECT * FROM pages WHERE PageParentID=".$ParentID." AND PageMenuOrder>=0 AND ((PageStartDate<'".date("Y-m-d H:i:s")."') OR (PageStartDate IS NULL)) AND ((PageEndDate>'".date("Y-m-d H:i:s")."') OR (PageEndDate IS NULL)) ORDER BY PageMenuOrder, PageMenuTitle");
		if ($MenuResponse && mysql_num_rows($MenuResponse)>0) {
			if ($UseAliasesInLinks && ($AliasPrepend==NULL)) {
				$AliasPrepend = GetPageAlias($ParentID);
			}
			while ($MenuObj = mysql_fetch_object($MenuResponse)) {
				$Permissions = intval(GetPagePermissionsSimple($MenuObj->PageID, $UserID, $Inherited));
				// $Permissions = intval(GetPagePermissions($MenuObj->PageID, $UserID));
				if (($Permissions & $P_VIEW)!=0) {
					if ($UseAliasesInLinks && $MenuObj->PageFileName && $AliasPrepend) {
						$t_url = ($AliasPrepend!="/"?$AliasPrepend:"")."/".$MenuObj->PageFileName;
						if ($CurrentID == $MenuObj->PageID) $output_cache .= "<li class=\"MenuCurrentPage\"><a href=\"$t_url\">".$MenuObj->PageMenuTitle."</a>";
						else $output_cache .= "<li><a href=\"$t_url\">".$MenuObj->PageMenuTitle."</a>";
						if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) $output_cache .= MenuChildrenUL($Parentage, $UserID, $CurrentID, $Permissions, $depth-1, $t_url);
					} else {
						if ($CurrentID == $MenuObj->PageID) $output_cache .= "<li class=\"MenuCurrentPage\"><a href=\"/pages/".$MenuObj->PageID.".php\">".$MenuObj->PageMenuTitle."</a>";
						else $output_cache .= "<li><a href=\"/pages/".$MenuObj->PageID.".php\">".$MenuObj->PageMenuTitle."</a>";
						if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) $output_cache .= MenuChildrenUL($Parentage, $UserID, $CurrentID, $Permissions, $depth-1);
					}
					$output_cache .= "</li>\n";
				}
			}
		} else {
			$e = mysql_error();
		}
		if ($output_cache != "") return "<ul>\n".$output_cache."</ul>\n";
		else return "";
	} else {
		return "";
	}
}

function GenerateMenu($PageID, $UserID, $depth=10000)
{
	global $MYSQL_DBName, $P_VIEW, $P_ADMIN, $UseAliasesInLinks;
	db_connect($MYSQL_DBName);

	$Parentage = GetParentage($PageID);
	$RootID = $Parentage[count($Parentage)-1];

	$Guest = GetGuestAccount();
	if ($Guest && $Guest->UserID==$UserID) {
		$MenuResponse = mysql_query("SELECT * FROM pages WHERE PageID=".$RootID);
		$MenuObj = mysql_fetch_object($MenuResponse);
		if ($MenuObj->PageGuestView) {
			$MenuResponse = mysql_query("SELECT * FROM pages WHERE PageID=".$RootID);
			$MenuObj = mysql_fetch_object($MenuResponse);
			echo("<div class=\"MenuPanel\">");
			if ($UseAliasesInLinks) {
				$t_url = GetPageAlias($MenuObj->PageID);
				if ($RootID == $PageID) echo("<div class=\"MenuItem\"><a href=\"$t_url\"><b>".$MenuObj->PageMenuTitle."</b></a>");
				else echo("<div class=\"MenuItem\"><a href=\"$t_url\">".$MenuObj->PageMenuTitle."</a>");
				if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) MenuChildrenGuest($Parentage,$PageID, $depth-1, $t_url);
			} else {
				if ($RootID == $PageID) echo("<div class=\"MenuItem\"><a href=\"/pages/".$MenuObj->PageID.".php\"><b>".$MenuObj->PageMenuTitle."</b></a>");
				else echo("<div class=\"MenuItem\"><a href=\"/pages/".$MenuObj->PageID.".php\">".$MenuObj->PageMenuTitle."</a>");
				if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) MenuChildrenGuest($Parentage,$PageID, $depth-1);
			}
			echo("</div></div>\n");
		}
	} else {
		if (UserIsAdmin($UserID)) $Permissions = $P_ADMIN;
		else $Permissions = GetPagePermissions($RootID, $UserID);
		if (($Permissions & $P_VIEW)>0) {
			$MenuResponse = mysql_query("SELECT * FROM pages WHERE PageID=".$RootID);
			$MenuObj = mysql_fetch_object($MenuResponse);
			echo("<div class=\"MenuPanel\">");
			if ($UseAliasesInLinks) {
				$t_url = GetPageAlias($MenuObj->PageID);
				if ($RootID == $PageID) echo("<div class=\"MenuItem\"><a href=\"$t_url\"><b>".$MenuObj->PageMenuTitle."</b></a>");
				else echo("<div class=\"MenuItem\"><a href=\"$t_url\">".$MenuObj->PageMenuTitle."</a>");
				if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) MenuChildren($Parentage, $UserID, $PageID, $Permissions, $depth-1, $t_url);
			} else {
				if ($RootID == $PageID) echo("<div class=\"MenuItem\"><a href=\"/pages/".$MenuObj->PageID.".php\"><b>".$MenuObj->PageMenuTitle."</b></a>");
				else echo("<div class=\"MenuItem\"><a href=\"/pages/".$MenuObj->PageID.".php\">".$MenuObj->PageMenuTitle."</a>");
				if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) MenuChildren($Parentage, $UserID, $PageID, $Permissions, $depth-1);
			}
			echo("</div></div>\n");
		}
	}
}

function GenerateMenuUL($PageID, $UserID, $depth=10000)
{
	global $MYSQL_DBName, $P_VIEW, $P_ADMIN, $UseAliasesInLinks;
	db_connect($MYSQL_DBName);
	
	$Parentage = GetParentage($PageID);
	$RootID = $Parentage[count($Parentage)-1];

	$Guest = GetGuestAccount();
	if ($UserID == $Guest->UserID) {
		// go into guest mode
		$MenuResponse = mysql_query("SELECT * FROM pages WHERE PageID=".$RootID);
		$MenuObj = mysql_fetch_object($MenuResponse);
		
		if ($MenuObj->PageGuestView) {
			echo ("<ul>\n");
			if ($UseAliasesInLinks) {
				$t_url = GetPageAlias($MenuObj->PageID);
				if ($RootID == $PageID) echo("<li class=\"MenuCurrentPage\"><a href=\"$t_url\">".$MenuObj->PageMenuTitle."</a>");
				else echo("<li><a href=\"$t_url\">".$MenuObj->PageMenuTitle."</a>");
				if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) echo (MenuChildrenGuestUL($Parentage, $PageID, $depth-1, $t_url));
			} else {
				if ($RootID == $PageID) echo("<li class=\"MenuCurrentPage\"><a href=\"/pages/".$MenuObj->PageID.".php\">".$MenuObj->PageMenuTitle."</a>");
				else echo("<li><a href=\"/pages/".$MenuObj->PageID.".php\">".$MenuObj->PageMenuTitle."</a>");
				if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) echo (MenuChildrenGuestUL($Parentage, $PageID, $depth-1));
			}
			echo ("</li></ul>\n");
		}
	} else {
		if (UserIsAdmin($UserID)) $Permissions = $P_ADMIN;
		else $Permissions = GetPagePermissions($RootID, $UserID);
		if (($Permissions & $P_VIEW)>0) {
			$MenuResponse = mysql_query("SELECT * FROM pages WHERE PageID=".$RootID);
			$MenuObj = mysql_fetch_object($MenuResponse);
			
			echo ("<ul>\n");
			if ($UseAliasesInLinks) {
				$t_url = GetPageAlias($MenuObj->PageID);
				if ($RootID == $PageID) echo("<li class=\"MenuCurrentPage\"><a href=\"$t_url\">".$MenuObj->PageMenuTitle."</a>");
				else echo("<li><a href=\"$t_url\">".$MenuObj->PageMenuTitle."</a>");
				if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) echo (MenuChildrenUL($Parentage, $UserID, $PageID, $Permissions, $depth-1, $t_url));
			} else {
				if ($RootID == $PageID) echo("<li class=\"MenuCurrentPage\"><a href=\"/pages/".$MenuObj->PageID.".php\">".$MenuObj->PageMenuTitle."</a>");
				else echo("<li><a href=\"/pages/".$MenuObj->PageID.".php\">".$MenuObj->PageMenuTitle."</a>");
				if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) echo (MenuChildrenUL($Parentage, $UserID, $PageID, $Permissions, $depth-1));
			}
			echo ("</li></ul>\n");
		}
	}
}

function GenerateMenuToParent($PageID, $UserID, $PageParentID, $ShowSiblings=false, $depth=10000, $ShowSelf=true)
{
	global $MYSQL_DBName, $P_VIEW, $P_ADMIN, $UseAliasesInLinks;
	db_connect($MYSQL_DBName);

	$FullParentage = GetParentage($PageID);
	$x=0;
	while(($x<count($FullParentage)) && ($FullParentage[$x]!=$PageParentID)) {
		$Parentage[$x] = $FullParentage[$x];
		$x++;
	}
	if ($x<count($FullParentage)) $Parentage[$x] = $FullParentage[$x];
	$RootID = $Parentage[count($Parentage)-1];

	$Guest = GetGuestAccount();

	if ($UserID == $Guest->UserID) {
		$MenuResponse = mysql_query("SELECT * FROM pages WHERE PageID=".$RootID);
		$MenuObj = mysql_fetch_object($MenuResponse);
		if ($MenuObj->PageGuestView) {
			echo("<div class=\"MenuPanel\">");
			if ($ShowSelf==true) {
				if ($MenuObj->PageParentID && $ShowSiblings) {
					$Parentage[] = $MenuObj->PageParentID;
					// remember not to count this level in the depth of the tree
					MenuChildren($Parentage, $UserID, $PageID, $Permissions, $depth);
				} else {
					if ($UseAliasesInLinks) {
						$t_url = GetPageAlias($MenuObj->PageID);
						if ($RootID == $PageID) echo("<div class=\"MenuItem\"><a href=\"$t_url\"><b>".$MenuObj->PageMenuTitle."</b></a>");
						else echo("<div class=\"MenuItem\"><a href=\"$t_url\">".$MenuObj->PageMenuTitle."</a>");
						if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) MenuChildrenGuest($Parentage, $PageID, $depth-1, $t_url);
					} else {
						if ($RootID == $PageID) echo("<div class=\"MenuItem\"><a href=\"/pages/".$MenuObj->PageID.".php\"><b>".$MenuObj->PageMenuTitle."</b></a>");
						else echo("<div class=\"MenuItem\"><a href=\"/pages/".$MenuObj->PageID.".php\">".$MenuObj->PageMenuTitle."</a>");
						if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) MenuChildrenGuest($Parentage, $PageID, $depth-1);
					}
					echo("</div>");
				}
			} else {
				// show the children but DON'T add this page's parent to the parentage
				// remember not to count this level in the depth of the tree
				MenuChildrenGuest($Parentage, $PageID, $depth);
			}
			echo("</div>\n");
		}
	} else {
		if (UserIsAdmin($UserID)) $Permissions = $P_ADMIN;
		else $Permissions = GetPagePermissions($RootID, $UserID);
		if (($Permissions & $P_VIEW)>0) {
			$MenuResponse = mysql_query("SELECT * FROM pages WHERE PageID=".$RootID);
			$MenuObj = mysql_fetch_object($MenuResponse);
			echo("<div class=\"MenuPanel\">");
			if ($ShowSelf==true) {
				if ($MenuObj->PageParentID && $ShowSiblings) {
					$Parentage[] = $MenuObj->PageParentID;
					// remember not to count this level in the depth of the tree
					MenuChildren($Parentage, $UserID, $PageID, $Permissions, $depth);
				} else {
					if ($UseAliasesInLinks) {
						$t_url = GetPageAlias($MenuObj->PageID);
						if ($RootID == $PageID) echo("<div class=\"MenuItem\"><a href=\"$t_url\"><b>".$MenuObj->PageMenuTitle."</b></a>");
						else echo("<div class=\"MenuItem\"><a href=\"$t_url\">".$MenuObj->PageMenuTitle."</a>");
						if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) MenuChildren($Parentage, $UserID, $PageID, $Permissions, $depth-1, $t_url);
					} else {
						if ($RootID == $PageID) echo("<div class=\"MenuItem\"><a href=\"/pages/".$MenuObj->PageID.".php\"><b>".$MenuObj->PageMenuTitle."</b></a>");
						else echo("<div class=\"MenuItem\"><a href=\"/pages/".$MenuObj->PageID.".php\">".$MenuObj->PageMenuTitle."</a>");
						if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) MenuChildren($Parentage, $UserID, $PageID, $Permissions, $depth-1);
					}
					echo("</div>");
				}
			} else {
				// show the children but DON'T add this page's parent to the parentage
				// remember not to count this level in the depth of the tree
				MenuChildren($Parentage, $UserID, $PageID, $Permissions, $depth);
			}
			echo("</div>\n");
		}
	}
}

function GenerateMenuToParentUL($PageID, $UserID, $PageParentID, $ShowSiblings=false, $depth=10000, $ShowSelf=true)
{
	global $MYSQL_DBName, $P_VIEW, $P_ADMIN, $UseAliasesInLinks;
	db_connect($MYSQL_DBName);

	$FullParentage = GetParentage($PageID);
	$x=0;
	while(($x<count($FullParentage)) && ($FullParentage[$x]!=$PageParentID)) {
		$Parentage[$x] = $FullParentage[$x];
		$x++;
	}
	if ($x<count($FullParentage)) $Parentage[$x] = $FullParentage[$x];
	$RootID = $Parentage[count($Parentage)-1];
	
	$Guest = GetGuestAccount();

	if ($UserID == $Guest->UserID) {
		$MenuResponse = mysql_query("SELECT * FROM pages WHERE PageID=".$RootID);
		$MenuObj = mysql_fetch_object($MenuResponse);
		if ($MenuObj->PageGuestView) {
			if ($ShowSelf == true) {
				if ($MenuObj->PageParentID && $ShowSiblings) {
					$Parentage[] = $MenuObj->PageParentID;
					// remember not to count this level in the depth of the tree
					echo MenuChildrenUL($Parentage, $UserID, $PageID, $Permissions, $depth);
				} else {
					echo ("<ul>\n");
					if ($UseAliasesInLinks) {
						$t_url = GetPageAlias($MenuObj->PageID);
						echo ("<li".($RootID==$PageID?" class=\"MenuCurrentPage\"":"")."><a href=\"/$t_url\">".$MenuObj->PageMenuTitle."</a>");
						if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) echo (MenuChildrenGuestUL($Parentage, $PageID, $depth-1, $t_url));
					} else {
						echo ("<li".($RootID==$PageID?" class=\"MenuCurrentPage\"":"")."><a href=\"/pages/".$MenuObj->PageID.".php\">".$MenuObj->PageMenuTitle."</a>");
						if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) echo (MenuChildrenGuestUL($Parentage, $PageID, $depth-1));
					}
					echo("</li>");
					echo ("</ul>\n");
				}
			} else {
				// show the children but DON'T add this page's parent to the parentage
				// remember not to count this level in the depth of the tree
				echo MenuChildrenGuestUL($Parentage, $PageID, $depth);
			}
		}
	} else {
		if (UserIsAdmin($UserID)) $Permissions = $P_ADMIN;
		else $Permissions = GetPagePermissions($RootID, $UserID);
		if (($Permissions & $P_VIEW)>0) {
			$MenuResponse = mysql_query("SELECT * FROM pages WHERE PageID=".$RootID);
			$MenuObj = mysql_fetch_object($MenuResponse);
			if ($ShowSelf == true) {
				if ($MenuObj->PageParentID && $ShowSiblings) {
					$Parentage[] = $MenuObj->PageParentID;
					// remember not to count this level in the depth of the tree
					echo MenuChildrenUL($Parentage, $UserID, $PageID, $Permissions, $depth);
				} else {
					echo ("<ul>\n");
					if ($UseAliasesInLinks) {
						$t_url = GetPageAlias($MenuObj->PageID);
						echo ("<li".($RootID==$PageID?" class=\"MenuCurrentPage\"":"")."><a href=\"/$t_url\">".$MenuObj->PageMenuTitle."</a>");
						if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) echo (MenuChildrenUL($Parentage, $UserID, $PageID, $Permissions, $depth-1, $t_url));
					} else {
						echo ("<li".($RootID==$PageID?" class=\"MenuCurrentPage\"":"")."><a href=\"/pages/".$MenuObj->PageID.".php\">".$MenuObj->PageMenuTitle."</a>");
						if ($Parentage[count($Parentage)-1] && $MenuObj->PageID==$Parentage[count($Parentage)-1]) echo (MenuChildrenUL($Parentage, $UserID, $PageID, $Permissions, $depth-1));
					}
					echo("</li>");
					echo ("</ul>\n");
				}
			} else {
				// show the children but DON'T add this page's parent to the parentage
				// remember not to count this level in the depth of the tree
				echo MenuChildrenUL($Parentage, $UserID, $PageID, $Permissions, $depth);
			}
		}
	}
}

function GeneratePageControls($PageID, $UserID, $ShowSiteControls = true)
{
	global $P_VIEW, $P_EDIT, $P_CREATE, $P_PUBLISH, $P_DELETE, $P_MANAGE, $username;
	$Permissions = GetPagePermissions($PageID, $UserID);
	$PageObj = mysql_fetch_object(mysql_query("SELECT * FROM pages, users WHERE pages.PageID=$PageID AND users.UserID=pages.PageModifiedBy"));
	if ($username != "guest") {
		?>
<style type="text/css">
	#SimplePageControls {
		position: fixed;
		right: 0px;
		top: 0px;
		width: 200px;
		overflow: hidden;
		background-color: #777;
		color: #FFF;
		font-size: 8pt;
		line-height: 1.2em;
		border-left: 4px solid #444;
		border-bottom: 4px solid #444;
		font-family: Segoe UI, Tahoma, Verdana, Arial, sans-serif;
	}

	#SimplePageControls a {
		color: #CCC;
		text-decoration: none;
		display: block;
	}
	
	#SimplePageControls #SimpleControls {
		padding: 10px;
		display: none;
	}
	
	#SimplePageControls #SimpleControls a:hover {
		color: #FFF;
		text-decoration: underline;
	}

	#SimplePageControls #SimplePageClickArea {
		font-size: 12pt;
		letter-spacing: 0.5em;
		color: #CCC;
		text-decoration: none;
		padding: 10px;
	}

	#SimplePageControls #SimpleControls h2 {
		font-size: 8pt;
		font-wieight: bold;
	}

	#SimplePageControls #SimpleControls ul {
		padding-left: 20px;
		margin: 0px;
	}
</style>
<script type="text/javascript">
	var spcIsOpen = false;
	
	function SimpleTogglePageControls() {
		var ClickArea = document.getElementById("SimplePageClickArea");
		var Controls = document.getElementById("SimpleControls");
		if (ClickArea && Controls) {
			if (spcIsOpen) {
				ClickArea.className = "closed";
				Controls.style.display = "none";
				spcIsOpen = false;
			} else {
				ClickArea.className = "open";
				Controls.style.display = "block";
				spcIsOpen = true;
			}
		}
	}
</script>
<div id="SimplePageControls">
	<a id="SimplePageClickArea" href="javascript:SimpleTogglePageControls();" class="closed">simple</a>
	<div id="SimpleControls">
		<?PHP
		if (($Permissions & ~$P_VIEW) != 0) {
			echo("<h2>page controls:</h2>\n");
			echo("<ul>\n");
			if (($Permissions & ($P_EDIT | $P_PUBLISH | $P_MANAGE))!=0) echo("<li><a href=\"/simple_cms/edit_page.php?PageID=".$PageID."\">edit</a></li>\n");
			if (($Permissions & $P_CREATE)!=0) echo("<li><a href=\"/simple_cms/create_page.php?ParentID=".$PageID."\">create child</a></li>\n");
			if (($Permissions & $P_DELETE)!=0) echo("<li><a href=\"/simple_cms/delete_page.php?PageID=".$PageID."\">delete</a></li>\n");
			if (($Permissions & $P_MANAGE)!=0) echo("<li><a href=\"/simple_cms/relocate_page.php?PageID=".$PageID."\">relocate</a></li>\n");
			if (($Permissions & $P_MANAGE)!=0) echo("<li><a href=\"/simple_cms/revisions.php?PageID=".$PageID."\">revisions</a></li>\n");
			if (($Permissions & $P_MANAGE)!=0) echo("<li><a href=\"/simple_cms/page_permissions.php?PageID=".$PageID."\">user permissions</a></li>\n");
			if (($Permissions & $P_MANAGE)!=0) echo("<li><a href=\"/simple_cms/page_group_permissions.php?PageID=".$PageID."\">group permissions</a></li>");
			echo("</ul>\n");

			echo("<h2>last modified</h2>\n");
			echo("<ul>\n");
			echo("<li>by: ".(($PageObj->UserFullName && $PageObj->UserFullName!="")?$PageObj->UserFullName:$PageObj->UserName)."</li>\n");
			echo("<li>on: ".$PageObj->PageModifiedOn."</li>\n");
			echo("</ul>\n");
		}
		if ($ShowSiteControls) {
			echo("<h2>site controls: </h2>");
			echo("<ul>\n");
			echo("<li><a href=\"/simple_cms/tab_pages.php\">mangagement console</a></li>\n");
			echo("<li><a href=\"/simple_cms/logout.php\">logout</a></li>\n");
			echo("</ul>\n");
			echo("<h2>current user</h2>\n");
			echo("<ul>\n");
			echo("<li>$username</li>\n");
			echo("</ul>\n");
		}
		?>
	</div>
</div>
		<?PHP
		/*
		echo("<div  style=\"padding: 5px; border: 1px solid #0000FF; background: #EEEEFF; font-family: Verdana; font-size: 8pt;\">");
		if (($Permissions & ~$P_VIEW) != 0) {
			echo("<b>Page Controls:</b> ");
			if (($Permissions & ($P_EDIT | $P_PUBLISH | $P_MANAGE))!=0) echo("(<a href=\"../simple_cms/edit_page.php?PageID=".$PageID."\">Edit</a>)");
			if (($Permissions & $P_CREATE)!=0) echo("(<a href=\"../simple_cms/create_page.php?ParentID=".$PageID."\">Create Child</a>)");
			if (($Permissions & $P_DELETE)!=0) echo("(<a href=\"../simple_cms/delete_page.php?PageID=".$PageID."\">Delete</a>)");
			if (($Permissions & $P_MANAGE)!=0) echo("(<a href=\"../simple_cms/relocate_page.php?PageID=".$PageID."\">Relocate</a>)");
			if (($Permissions & $P_MANAGE)!=0) echo("(<a href=\"../simple_cms/revisions.php?PageID=".$PageID."\">Revisions</a>)");
			if (($Permissions & $P_MANAGE)!=0) echo("(<a href=\"../simple_cms/page_permissions.php?PageID=".$PageID."\">User Permissions</a>)");
			if (($Permissions & $P_MANAGE)!=0) echo("(<a href=\"../simple_cms/page_group_permissions.php?PageID=".$PageID."\">Group Permissions</a>)");
			echo("<b>Last Modified by </b>".(($PageObj->UserFullName && $PageObj->UserFullName!="")?$PageObj->UserFullName:$PageObj->UserName)." <b>on</b> ".$PageObj->PageModifiedOn);
		}
		if ($ShowSiteControls) {
			echo(" <b>Site Controls: </b>");
			echo("(<a href=\"../simple_cms/tab_pages.php\">Mangagement Console</a>)");
			echo("(<a href=\"../simple_cms/logout.php\">Logout</a>)");
			echo(" <b>Current User: </b>$username");
		}
		echo("</div>\n");
		*/
	}
}

function GenerateManagementConsoleLinks($Section = NULL)
{
	global $username;
	if ($Section && $username!="guest") {
		?>
		<div id="ManagementConsole">
			<ul>
				<li <?PHP echo ($Section=="pages")?"class=\"selected\"":"";?>><a href="/simple_cms/tab_pages.php">Pages</a></li>
				<li <?PHP echo ($Section=="users")?"class=\"selected\"":"";?>><a href="/simple_cms/tab_users.php">Users</a></li>
				<li <?PHP echo ($Section=="groups")?"class=\"selected\"":"";?>><a href="/simple_cms/tab_groups.php">Groups</a></li>
				<li <?PHP echo ($Section=="logs")?"class=\"selected\"":"";?>><a href="/simple_cms/tab_logs.php">Logs</a></li>
				<li <?PHP echo ($Section=="images")?"class=\"selected\"":"";?>><a href="/simple_cms/tab_images.php">Images</a></li>
				<li <?PHP echo ($Section=="templates")?"class=\"selected\"":"";?>><a href="/simple_cms/tab_templates.php">Templates</a></li>
				<li><a href="/simple_cms/logout.php">Logout</a></li>
			</ul>
		</div>
		<?PHP
		/*
		// container
		echo("<div style=\"width:100%\">");
		// pages
		echo("<div style=\"width: 0px; border-top: 1px solid #FFFFFF; border-bottom: 1px solid #777777; padding: 4px; float: left;\">&nbsp</div>");
		if ($Section=="pages") echo("<div style=\"width:auto; float: left; border: 1px solid #777777; border-bottom: 1px solid #FFFFFF; background: #FFFFFF; padding: 4px;\"><a href=\"../simple_cms/tab_pages.php\">Pages</a></div>");
		else echo("<div style=\"width:auto; float: left; border: 1px solid #777777; background: #EEEEEE; padding: 4px;\"><a href=\"../simple_cms/tab_pages.php\">Pages</a></div>");
		// users
		echo("<div style=\"width: 0px; border-top: 1px solid #FFFFFF; border-bottom: 1px solid #777777; padding: 4px; float: left;\">&nbsp</div>");
		if ($Section=="users") echo("<div style=\"width:auto; float: left; border: 1px solid #777777; border-bottom: 1px solid #FFFFFF; background: #FFFFFF; padding: 4px;\"><a href=\"../simple_cms/tab_users.php\">Users</a></div>");
		else echo("<div style=\"width:auto; float: left; border: 1px solid #777777; background: #EEEEEE; padding: 4px;\"><a href=\"../simple_cms/tab_users.php\">Users</a></div>");
		// groups
		echo("<div style=\"width: 0px; border-top: 1px solid #FFFFFF; border-bottom: 1px solid #777777; padding: 4px; float: left;\">&nbsp</div>");
		if ($Section=="groups") echo("<div style=\"width:auto; float: left; border: 1px solid #777777; border-bottom: 1px solid #FFFFFF; background: #FFFFFF; padding: 4px;\"><a href=\"../simple_cms/tab_groups.php\">Groups</a></div>");
		else echo("<div style=\"width:auto; float: left; border: 1px solid #777777; background: #EEEEEE; padding: 4px;\"><a href=\"../simple_cms/tab_groups.php\">Groups</a></div>");
		// logs
		echo("<div style=\"width: 0px; border-top: 1px solid #FFFFFF; border-bottom: 1px solid #777777; padding: 4px; float: left;\">&nbsp</div>");
		if ($Section=="logs") echo("<div style=\"width:auto; float: left; border: 1px solid #777777; border-bottom: 1px solid #FFFFFF; background: #FFFFFF; padding: 4px;\"><a href=\"../simple_cms/tab_logs.php\">Logs</a></div>");
		else echo("<div style=\"width:auto; float: left; border: 1px solid #777777; background: #EEEEEE; padding: 4px;\"><a href=\"../simple_cms/tab_logs.php\">Logs</a></div>");
		// images
		echo("<div style=\"width: 0px; border-top: 1px solid #FFFFFF; border-bottom: 1px solid #777777; padding: 4px; float: left;\">&nbsp</div>");
		if ($Section=="images") echo("<div style=\"width:auto; float: left; border: 1px solid #777777; border-bottom: 1px solid #FFFFFF; background: #FFFFFF; padding: 4px;\"><a href=\"../simple_cms/tab_images.php\">Images</a></div>");
		else echo("<div style=\"width:auto; float: left; border: 1px solid #777777; background: #EEEEEE; padding: 4px;\"><a href=\"../simple_cms/tab_images.php\">Images</a></div>");
		// templates
		echo("<div style=\"width: 0px; border-top: 1px solid #FFFFFF; border-bottom: 1px solid #777777; padding: 4px; float: left;\">&nbsp</div>");
		if ($Section=="templates") echo("<div style=\"width:auto; float: left; border: 1px solid #777777; border-bottom: 1px solid #FFFFFF; background: #FFFFFF; padding: 4px;\"><a href=\"../simple_cms/tab_templates.php\">Templates</a></div>");
		else echo("<div style=\"width:auto; float: left; border: 1px solid #777777; background: #EEEEEE; padding: 4px;\"><a href=\"../simple_cms/tab_templates.php\">Templates</a></div>");
		// log out
		echo("<div style=\"width: 0px; border-top: 1px solid #FFFFFF; border-bottom: 1px solid #777777; padding: 4px; float: left;\">&nbsp</div>");
		echo("<div style=\"width:auto; float: left; border: 1px solid #777777; background: #EEEEEE; padding: 4px;\"><a href=\"../simple_cms/logout.php\">Logout</a></div>");
		// end container
		echo("<div style=\"border-top: 1px solid #FFFFFF; border-bottom: 1px solid #777777; padding: 4px;\">&nbsp</div>");
		echo("</div>");
		echo("<div style=\"clear:both;\"></div>\n");
		*/
		
	}
}

function LogWrite($UserID, $LogType, $Message)
{
	db_connect_a($MYSQL_DBName);
	
	$UserID = intval($UserID);
	$UserResponse = mysql_query("SELECT * FROM users WHERE UserID=$UserID");
	if ($UserResponse && mysql_num_rows($UserResponse)>0) {
		$UserObj = mysql_fetch_object($UserResponse);
		$UserName = fix_apos($UserObj->UserName);
	} else {
		$UserName = "";
	}
	$IPAddress = $_SERVER['REMOTE_ADDR'];
	$PageURL = fix_apos($_SERVER['PHP_SELF']);
	$Timestamp = date("Y-m-d H:i:s");
	$LogType = fix_apos($LogType);
	$Message = fix_apos($Message);
	
	$LogQuery = "INSERT INTO log (LogUserID, LogUserName, LogMessage, LogTimestamp, LogPageURL, LogIPAddress, LogType) VALUES (";
	$LogQuery .= "$UserID, ";
	$LogQuery .= "'$UserName', ";
	$LogQuery .= "'$Message', ";
	$LogQuery .= "'$Timestamp', ";
	$LogQuery .= "'$PageURL', ";
	$LogQuery .= "'$IPAddress', ";
	$LogQuery .= "'$LogType')";
	mysql_query($LogQuery);
	echo(mysql_error());
}

function GetFlattenedChildren($LocalParentID, $UserID)
{
	global $P_VIEW;

	$FlatIDList = "";
	$FlatNameList = "";
	
	$FlatResponse = mysql_query("SELECT * FROM pages WHERE PageParentID=$LocalParentID ORDER BY PageMenuOrder, PageMenuTitle");
	echo mysql_error();

	if ($FlatResponse && mysql_num_rows($FlatResponse)>0) {
		while ($FlatObj = mysql_fetch_object($FlatResponse)) {
			$Permissions = GetPagePermissions($FlatObj->PageID, $UserID);
			if ($Permissions & $P_VIEW) {
				$FlatIDList .= ($FlatIDList==""?"":"\t").$FlatObj->PageID;
				$FlatNameList .= ($FlatNameList==""?"":"\t").$FlatObj->PageMenuTitle;
				$str = GetFlattenedChildren($FlatObj->PageID, $UserID);
				if ($str && ($str != "\n")) {
					$str = explode("\n", $str);
					$FlatIDList .= "\t".$str[0];
					$FlatNameList .= "\t".$str[1];
				}
			}
		}		
	}

	return $FlatIDList."\n".$FlatNameList;
}

function GenerateNextLast($ParentID, $PageID, $UserID)
{
	global $UseAliasesInLinks;

	$FlatList = GetFlattenedChildren($ParentID, $UserID);

	if ($FlatList && ($FlatList != "\n")) {

		$FlatList = explode("\n", $FlatList);
		$PageIDList = explode("\t", $FlatList[0]);
		$PageNameList = explode("\t", $FlatList[1]);
	
		$lastpage = count($PageIDList)-1;
		$pageindex = array_search($PageID, $PageIDList);

		if (!($pageindex===NULL || $pageindex===FALSE)) {
			// previous
			if ($pageindex>0) {
				if ($UseAliasesInLinks) echo ("<a href=\"".GetPageAlias($PageIDList[$pageindex-1])."\">");
				else echo "<a href=\"/pages/".$PageIDList[$pageindex-1].".php\">";
				echo "Previous: ".$PageNameList[$pageindex-1];
				echo "</a> - ";
			} else {
				if ($UseAliasesInLinks) echo ("<a href=\"".GetPageAlias($ParentID)."\">");
				else echo "<a href=\"/pages/".$ParentID.".php\">";
				echo "Home";
				echo "</a> - ";
			}
			// current
			echo "Page ".($pageindex+1)." of ".($lastpage+1);
			// next
			if ($pageindex<$lastpage) {
				if ($UseAliasesInLinks) echo " - <a href=\"".GetPageAlias($PageIDList[$pageindex+1])."\">";
				else echo " - <a href=\"/pages/".$PageIDList[$pageindex+1].".php\">";
				echo "Next: ".$PageNameList[$pageindex+1];
				echo "</a>";
			} else {
				if ($UseAliasesInLinks) echo (" - <a href=\"".GetPageAlias($ParentID)."\">");
				else echo " - <a href=\"/pages/".$ParentID.".php\">";
				echo "Home";
				echo "</a>";
			}
		}
	}
}


function GetChildList($ParentPageID, $UserID)
{
	global $P_VIEW;
	$ChildIDList = null;
	$Permissions = GetPagePermissions($ParentPageID, $UserID);
	if (($Permissions & $P_VIEW) != 0) {
		$now = date("Y-m-d H:i:s");
		$ChildResponse = mysql_query("SELECT * FROM pages WHERE PageParentID=$ParentPageID AND (PageStartDate<='$now' OR PageStartDate IS NULL) AND (PageEndDate>='$now' OR PageEndDate IS NULL)");
		if ($ChildResponse && mysql_num_rows($ChildResponse)>0) {
			while ($ChildObj = mysql_fetch_object($ChildResponse)) {
				$ChildIDList[] = $ChildObj->PageID;
			}
		} else {
			echo mysql_error();
		}
	}
	
	return $ChildIDList;
}

function GetRandomChild($ParentPageID, $UserID)
{
	$ChildIDList = GetChildList($ParentPageID, $UserID);
	if ($ChildIDList && is_array($ChildIDList)) {
		return $ChildIDList[rand(0, count($ChildIDList)-1)];
	} else {
		return null;
	}
}

function GetPageBody($PageID, $UserID)
{
	global $P_VIEW;
	$Permissions = GetPagePermissions($PageID, $UserID);
	if (($Permissions & $P_VIEW)!=0) {
		$PageResponse = mysql_query("SELECT * FROM pages WHERE PageID=$PageID");
		if ($PageResponse && mysql_num_rows($PageResponse)>0) {
			$PageObj = mysql_fetch_object($PageResponse);
			return $PageObj->PageBody;
		} else {
			return null;
		}
	} else {
		return null;
	}
}

function GetPageTitle($PageID, $UserID)
{
	global $P_VIEW;
	$Permissions = GetPagePermissions($PageID, $UserID);
	if (($Permissions & $P_VIEW)!=0) {
		$PageResponse = mysql_query("SELECT * FROM pages WHERE PageID=$PageID");
		if ($PageResponse && mysql_num_rows($PageResponse)>0) {
			$PageObj = mysql_fetch_object($PageResponse);
			return $PageObj->PageTitle;
		} else {
			return null;
		}
	} else {
		return null;
	}
}

function GetGuestAccount()
{
	$UserResponse = mysql_query("SELECT * FROM users WHERE UserName='guest'");
	if ($UserResponse && mysql_num_rows($UserResponse)>0) {
		$UserObj = mysql_fetch_object($UserResponse);
		return $UserObj;
	} else {
		echo mysql_error();
		return null;
	}
}

function UpdateGuestViewSimple($PageID, $UserID, $Inherited)
{
	global $P_VIEW;
	
	$Permissions = GetPagePermissionsSimple($PageID, $UserID, $Inherited);
	if (($Permissions & $P_VIEW)>0) {
		mysql_query("UPDATE pages SET PageGuestView=1 WHERE PageID=".$PageID);
	} else {
		mysql_query("UPDATE pages SET PageGuestView=0 WHERE PageID=".$PageID);
	}
	$ChildResponse = mysql_query("SELECT * FROM pages WHERE PageParentID=".$PageID);
	if ($ChildResponse && mysql_num_rows($ChildResponse)>0) {
		while ($ChildObj = mysql_fetch_object($ChildResponse)) {
			UpdateGuestViewSimple($ChildObj->PageID, $UserID, $Permissions);
		}
	}
}

function UpdateGuestView($PageID)
{
	global $P_VIEW;
	
	$Guest = GetGuestAccount();
	if ($Guest) {
		$Permissions = GetPagePermissions($PageID, $Guest->UserID);
		if (($Permissions & $P_VIEW)>0) {
			mysql_query("UPDATE pages SET PageGuestView=1 WHERE PageID=".$PageID);
		} else {
			mysql_query("UPDATE pages SET PageGuestView=0 WHERE PageID=".$PageID);
		}
		$ChildResponse = mysql_query("SELECT * FROM pages WHERE PageParentID=".$PageID);
		if ($ChildResponse && mysql_num_rows($ChildResponse)>0) {
			while ($ChildObj = mysql_fetch_object($ChildResponse)) {
				UpdateGuestViewSimple($ChildObj->PageID, $Guest->UserID, $Permissions);
			}
		}
	} else {
	}
}

function MySQLToTimestamp($str) {

	list($date, $time) = explode(' ', $str);
	list($year, $month, $day) = explode('-', $date);
	list($hour, $minute, $second) = explode(':', $time);

	return mktime($hour, $minute, $second, $month, $day, $year);
}

function BlogInterface($ParentPageID, $UserID, $PostsPerPage=20, $DisplayAuthors=true)
{
	global $P_VIEW, $P_EDIT, $P_CREATE;
	global $CurrentPageID, $UseAliasesInLinks;
	
	$Permissions = GetPagePermissions($ParentPageID, $UserID);
	if (($Permissions & $P_VIEW)>0) {
		echo ("<div id=\"SimpleBlog\">\n");
		if ($_GET["PostID"]) {
			$gPostID= intval($_GET["PostID"]);
			$now = date("Y-m-d H:i:s");
			$PageResponse = mysql_query("SELECT * FROM pages WHERE PageID=$gPostID AND PageParentID=$ParentPageID AND (PageStartDate IS NULL OR PageStartDate<='$now') AND (PageEndDate IS NULL OR PageEndDate>='$now')");
			if ($PageResponse && mysql_num_rows($PageResponse)>0) {
				$p = mysql_fetch_object($PageResponse);
				$p->Permissions = GetPagePermissionsSimple($p->PageID, $UserID, $Permissions);
				
				if (($p->Permissions & $P_VIEW)>0) {

					$ts = MySQLToTimestamp($p->PageCreatedOn);
					echo ("<div id=\"SimpleBlogPost\">\n");
					
					echo ("<h2>".$p->PageTitle."</h2>\n");
					echo ("<p id=\"SimpleBlogByline\">created");
					if ($DisplayAuthors) {
						$UserResponse = mysql_query("SELECT * FROM users WHERE UserID=".$p->PageCreatedBy);
						if ($UserResponse && mysql_num_rows($UserResponse)>0) {
							$a = mysql_fetch_object($UserResponse);
							echo " by ".($a->UserFullName?$a->UserFullName:$a->UserName);
						}
					}
					echo (" on ".date("l F j, Y", $ts)." at ".date("g:i a", $ts));
					if (($p->Permissions & $P_EDIT)>0) {
						echo (" (<a href=\"/simple_cms/edit_page.php?PageID=".$p->PageID."\">edit</a>)");
					}
					echo ("</p>\n");
					
					echo ("<div id=\"SimpleBlogPostContent\">\n");
					$content = $p->PageBody;
					echo $content;
					echo ("</div>\n");
					if ($UseAliasesInLinks) echo ("<p><a href=\"".GetPageAlias($CurrentPageID)."\">return to posts</a></p>\n");
					else echo ("<p><a href=\"/pages/".$CurrentPageID.".php\">return to posts</a></p>\n");
					echo ("</div>\n");

				}
			}
		} else if ($_GET["FilterKeyword"]) {
			$gFilterKeyword = $_GET["FilterKeyword"];
		} else {
			// find out what the offset is
			if ($_GET["Offset"]) {
				$gOffset = $_GET["Offset"];
			} else {
				$gOffset = 0;
			}
			
			// get all the child posts
			$ChildList = null;
			$now = date("Y-m-d H:i:s");
			$ChildResponse = mysql_query("SELECT * FROM pages WHERE PageParentID=$ParentPageID AND (PageStartDate IS NULL OR PageStartDate<='$now') AND (PageEndDate IS NULL OR PageEndDate>='$now') ORDER BY PageCreatedOn DESC");
			if ($ChildResponse && mysql_num_rows($ChildResponse)>0) {
				while ($ChildObj = mysql_fetch_object($ChildResponse)) {
					$ChildPermissions = GetPagePermissionsSimple($ChildObj->PageID, $UserID, $Permissions);
					if (($ChildPermissions & $P_VIEW)>0) {
						$ChildObj->Permissions = $ChildPermissions;
						$ChildList[] = $ChildObj;
					}
				}
			} else {
				echo mysql_error();
			}
			
			if (($Permissions & $P_CREATE)>0) {
				echo ("<p><a href=\"/simple_cms/create_page.php?ParentID=$ParentPageID\">Add a Post</a></p>\n");
			}
			
			if ($ChildList) {
				// dispalys posts [$gOffset, $max)
				// must keep $gOffset and $max in bounds
				$nPosts = count($ChildList);
				if ($gOffset >= $nPosts) $gOffset = 0;
				if ($gOffset < 0) $gOffset = 0;
				$max = $gOffset+$PostsPerPage;
				if ($max>$nPosts) $max = $nPosts;
				
				$AuthorsList =  array();
				
				for ($x=$gOffset;$x<$max;$x++) {
					$p = $ChildList[$x];
					$ts = MySQLToTimestamp($p->PageCreatedOn);
					echo ("<div id=\"SimpleBlogPost\">\n");
					
					echo ("<h2><a href=\"".($UseAliasesInLinks?GetPageAlias($ParentPageID):"/pages/$ParentPageID.php")."?PostID=".$p->PageID."\">".$p->PageTitle."</a></h2>\n");
					echo ("<p id=\"SimpleBlogByline\">created");
					if ($DisplayAuthors) {
						if (isset($AuthorsList[$p->PageCreatedBy])) {
							$a = $AuthorsList[$p->PageCreatedBy];
						} else {
							$UserResponse = mysql_query("SELECT * FROM users WHERE UserID=".$p->PageCreatedBy);
							if ($UserResponse && mysql_num_rows($UserResponse)>0) {
								$a = mysql_fetch_object($UserResponse);
								$AuthorsList[$p->PageCreatedBy] = $a;
							} else {
								$a = null;
							}
						}
						if ($a) {
							echo " by ".($a->UserFullName?$a->UserFullName:$a->UserName);
						}
					}
					echo (" on ".date("l F j, Y", $ts)." at ".date("g:i a", $ts));
					if (($p->Permissions & $P_EDIT)>0) {
						echo (" (<a href=\"/simple_cms/edit_page.php?PageID=".$p->PageID."\">edit</a>)");
					}
					echo ("</p>\n");
					
					echo ("<div id=\"SimpleBlogPostContent\">\n");
					$content = $p->PageBody;
					if (strpos(strtolower($content), "<!-- break -->")!==FALSE) {
						$offs = strpos(strtolower($content), "<!-- break -->");
						$content = substr($content, 0, $offs);
					} else {
						$offs = strpos(strtolower($content), "<p");
						if ($offs!==false && $offs<10) {
							$offs = strpos(strtolower($content), "<p", $offs+1);
						}
						if ($offs!==false) {
							$content = substr($content, 0, $offs);
						}
					}
					echo $content;
					echo ("<p><a href=\"".($UseAliasesInLinks?GetPageAlias($ParentPageID):"/pages/$ParentPageID.php")."?PostID=".$p->PageID."\">more ...</a></p>\n");
					echo ("</div>\n");
					
					echo ("</div>\n");
				}
				if ($gOffset > 0) {
					echo ("<p id=\"SimpleBlogPrevious\"><a href=\"".($UseAliasesInLinks?GetPageAlias($ParentPageID):"/pages/$ParentPageID.php")."?Offset=".($gOffset-$PostsPerPage)."\">Newer Posts</a></p>");
				}
				if ($max<$nPosts) {
					echo ("<p id=\"SimpleBlogNext\"><a href=\"".($UseAliasesInLinks?GetPageAlias($ParentPageID):"/pages/$ParentPageID.php")."?Offset=".($gOffset+$PostsPerPage)."\">Older Posts</a></p>\n");
				}
			} else {
				echo ("<p><i>This blog does not yet have any posts.</i></p>\n");
			}
			
			print_r($ChildObj);
		}
		echo ("</div>\n");
	}
	
}

// PHP 4 compatability functions
//		These PHP5 functions are used by the installer.  Equivalents must
//		be defined for PHP4 servers.

if (!function_exists("file_get_contents")) {
	function file_get_contents($filename) {
		$fp = @fopen($filename, "r");
		if ($fp === FALSE) return FALSE;
		$contents = @fread($fp, @filesize($filename));
		fclose($fp);
		return $contents;
	}
}

if (!function_exists("file_put_contents")) {
	function file_put_contents($filename, $contents) {
		$fp = @fopen($filename, "w");
		if ($fp === FALSE) return FALSE;
		$BytesWritten = fwrite($fp, $contents);
		fclose($fp);
		return $BytesWritten;
	}
}

// LDAP Authorization
function LDAPAuth($aUsername, $aPassword) {
	global $LDAP_host, $LDAP_search_dn, $LDAP_port, $LDAP_search_pattern, $LDAP_bind_dn, $LDAP_bind_pw;
	$attrs = array("dn");
	
	$connect_id = @ldap_connect($LDAP_host, $LDAP_port);
	if ($connect_id) {
		$bind_result = null;
		if ($LDAP_bind_dn) {
			$bind_result = @ldap_bind($connect_id, $LDAP_bind_dn, $LDAP_bind_pw);
		} else {
			$bind_result = @ldap_bind($connect_id);
		}
		if ($bind_result) {
			$search_result = @ldap_search($connect_id, $LDAP_search_dn, str_replace("[SIMPLE_USERNAME]", $aUsername, $LDAP_search_pattern), $attrs);
			if ($search_result!==FALSE) {
				$entries = @ldap_get_entries($connect_id, $search_result);
				if (is_array($entries) && isset($entries[0]) && isset($entries[0]["dn"])) {
					$bind_result = @ldap_bind($connect_id, $entries[0]["dn"], $aPassword);
					if ($bind_result) {
						ldap_close($connect_id);
						return true;
					} else {
						ldap_close($connect_id);
						return false;
					}
				} else {
					ldap_close($connect_id);
					return false;
				}
			} else {
				ldap_close($connect_id);
				return false;
			}
		} else {
			ldap_close($connect_id);
			return false;
		}
	} else {
		return false;
	}
}

function LDAPGetUser($aUsername) {
	global $LDAP_host, $LDAP_search_dn, $LDAP_port, $LDAP_search_pattern, $LDAP_bind_dn, $LDAP_bind_pw;
	$attrs = array("dn");
	
	$connect_id = @ldap_connect($LDAP_host, $LDAP_port);
	if ($connect_id) {
		$bind_result = null;
		if ($LDAP_bind_dn) {
			$bind_result = @ldap_bind($connect_id, $LDAP_bind_dn, $LDAP_bind_pw);
		} else {
			$bind_result = @ldap_bind($connect_id);
		}
		if ($bind_result) {
			$search_result = @ldap_search($connect_id, $LDAP_search_dn, str_replace("[SIMPLE_USERNAME]", $aUsername, $LDAP_search_pattern));
			if ($search_result!==FALSE) {
				$entries = @ldap_get_entries($connect_id, $search_result);
				if (is_array($entries) && isset($entries[0]) && isset($entries[0]["dn"])) {
					return $entries[0];
				} else {
					ldap_close($connect_id);
					return false;
				}
			} else {
				ldap_close($connect_id);
				return false;
			}
		} else {
			ldap_close($connect_id);
			return false;
		}
	} else {
		return false;
	}
}

function GetAliasFromPath($path, $ParentID=NULL) {
	
	if ($ParentID == NULL) {
		$HomepageResponse = mysql_query("SELECT * FROM pages WHERE PageParentID IS NULL");
		if ($HomepageResponse && mysql_num_rows($HomepageResponse)>0) {
			$HomepageObj = mysql_fetch_object($HomepageResponse);
			$ParentID = $HomepageObj->PageID;
		} else {
			return false;
		}
	}
	
	// get the last thing in the array
	$token = array_pop($path);
	
	// if there's nothing left or we've hit a trailing slash, return the parent ID
	if ($token===null || trim($token)=="") return $ParentID;
	
	// otherwise, see if there's a page at this level that matches the token
	$ParentResponse = mysql_query("SELECT PageID FROM pages WHERE PageParentID=".intval($ParentID)." AND PageFileName='".fix_apos($token)."'");
	if ($ParentResponse && mysql_num_rows($ParentResponse)>0) {
		// if there is, we recursively call this function with the popped path
		$ParentObj = mysql_fetch_object($ParentResponse);
		return (GetAliasFromPath($path, $ParentObj->PageID));
	} else {
		// if there's not then this alias maps to nothing
		echo mysql_error();
		return false;
	}
}

function LookupAlias($uri) {
	// remove leading slash
	if (strpos($uri,"/")==0) {
		$uri = substr($uri, 1);
	}
	// not interested in querystring
	$uri = explode("?", $uri);
	$uri = $uri[0];
	// split by slashes
	$uri = explode("/", $uri);
	$uri = array_reverse($uri);
	// now call recursive function
	return GetAliasFromPath($uri);
}

function GenerateDefaultFileNames() {
	$PageResponse = mysql_query("SELECT * FROM pages WHERE PageFileName IS NULL");
	if ($PageResponse && mysql_num_rows($PageResponse)>0) {
		while ($PageObj = mysql_fetch_object($PageResponse)) {
			$matches = Array();
			$nMatches = 0;
			$nMatches = preg_match_all('/[0-9a-z]*/', strtolower($PageObj->PageMenuTitle?$PageObj->PageMenuTitle:$PageObj->PageTitle), $matches);
			if ($nMatches>0) {
				$VirtualFileName = trim(implode("", $matches[0]));
				mysql_query("UPDATE pages SET PageFileName='".addslashes($VirtualFileName)."' WHERE PageID=".$PageObj->PageID);
			}
		}
	}
}

function AliasMapRecurse($ParentID, $prepend="/") {
	$ChildResponse = mysql_query("SELECT * FROM pages WHERE PageParentID=".intval($ParentID)." AND PageFileName IS NOT NULL");
	if ($ChildResponse && mysql_num_rows($ChildResponse)>0) {
		while ($ChildObj = mysql_fetch_object($ChildResponse)) {
			echo ($prepend.$ChildObj->PageFileName."\t/pages/".$ChildObj->PageID.".php\n");
			AliasMapRecurse($ChildObj->PageID, $prepend.$ChildObj->PageFileName."/");
		}
	}
}

function ExportAliasMap() {
	// first fetch the site root
	$ParentResponse = mysql_query("SELECT * FROM pages WHERE PageParentID IS NULL");
	if ($ParentResponse && mysql_num_rows($ParentResponse)>0) {
		$ParentObj = mysql_fetch_object($ParentResponse);
		ob_start();
		echo ("# SIMPLE CMS - Page Alias Table\n");
		echo ("# DO NOT ALTER MANUALLY - This file is automatically generated when \$MaintainAliasList == true in your settings file.\n");
		echo ("# To be used with Apache's mod_rewrite RewriteMap functionality.\n\n");
		
		echo ("/\t/pages/".$ParentObj->PageID.".php\n");
		AliasMapRecurse($ParentObj->PageID, "/");
		
		$output = ob_get_contents();
		ob_end_clean();
		file_put_contents($_SERVER["DOCUMENT_ROOT"]."/simple_cms/simple_rewrite.map", $output);
	}
}

include_once ("custom_functions.php");
?>