<?PHP
header("Content-type: text/html; charset=utf-8");
error_reporting(0);
include_once("./include/global.php");

import_request_variables("p","p");
import_request_variables("g","g");

// escape quotes in a short function call for convenience
function eq($str) {
	return str_replace("\"", "\\\"", $str);
}

if ($gDoSQLSetup && $gDoSQLSetup=="true") {
	// get the sql we need to create the tables
	$sql = file_get_contents("install.sql");
	$sql = str_replace("\n", " ", $sql);
	$sql = str_replace("\r", "", $sql);
	$temp = explode(";", $sql);
	$sql = null;
	for ($x=0;$x<count($temp);$x++) {
		if (trim($temp[$x])!="") {
			$sql[] = trim($temp[$x]);
		}
	}
	
	
	// create a variable to hold errors
	$e = null;
	
	$conn = db_connect_a($MYSQL_DBName);
	if (!$conn) {
		$e[] = "Failed to make database connection: ".mysql_error()."<br />(HALTING ADDITIONAL SQL STATEMENTS)";
	} else {
		foreach ($sql as $s) {
			$response = mysql_query($s);
			if (!$response) {
				$e[] = mysql_error()."<br />".$s;
			}
		}
		
		// if we got through making the tables okay, let's make the database entries
		if ($e==null) {
			$UserID = null;
			$GroupID = null;
			$TemplateID = null;
			$RootPageID = null;
			
			// ------------------------------------------------------------
			// users
			$Permissions = $P_VIEW | $P_EDIT | $P_CREATE | $P_PUBLISH | $P_DELETE | $P_MANAGE | $P_IMAGES | $P_ADMIN;
			$s = "INSERT INTO users (UserName, UserPassword, UserPermissions, UserIsAdmin) VALUES ('webmaster', '".GetPasswordHashValue("webmaster","default")."', $Permissions, 'Y')";
			$response = mysql_query($s);
			if ($response) {
				$UserID["webmaster"] = mysql_insert_id();
			} else {
				$e[] = mysql_error()."<br />".$s;
			}
			
			$Permissions = $P_VIEW;
			$s = "INSERT INTO users (UserName, UserPassword, UserPermissions, UserIsAdmin) VALUES ('guest', '".GetPasswordHashValue("guest","")."', $Permissions, 'N')";
			$response = mysql_query($s);
			if ($response) {
				$UserID["guest"] = mysql_insert_id();
			} else {
				$e[] = mysql_error()."<br />".$s;
			}
			
			// ------------------------------------------------------------
			// groups
			$s = "INSERT INTO groups (GroupName, GroupDescription, GroupIsAdmin) VALUES ('webmasters', 'Site Administrators', 'Y')";
			$response = mysql_query($s);
			if ($response) {
				$GroupID["webmasters"] = mysql_insert_id();
			} else {
				$e[] = mysql_error()."<br />".$s;
			}
			
			$s = "INSERT INTO groups (GroupName, GroupDescription, GroupIsAdmin) VALUES ('everybody', 'Every User', 'N')";
			$response = mysql_query($s);
			if ($response) {
				$GroupID["everybody"] = mysql_insert_id();
			} else {
				$e[] = mysql_error()."<br />".$s;
			}
			
			// ------------------------------------------------------------
			// put users in groups
			$s = "INSERT INTO usersgroupslink (UserID, GroupID) VALUES (".$UserID["webmaster"].", ".$GroupID["webmasters"].")";
			$response = mysql_query($s);
			if ($response) {
			} else {
				$e[] = mysql_error()."<br />".$s;
			}
			$s = "INSERT INTO usersgroupslink (UserID, GroupID) VALUES (".$UserID["webmaster"].", ".$GroupID["everybody"].")";
			$response = mysql_query($s);
			if ($response) {
			} else {
				$e[] = mysql_error()."<br />".$s;
			}
			$s = "INSERT INTO usersgroupslink (UserID, GroupID) VALUES (".$UserID["guest"].", ".$GroupID["everybody"].")";
			$response = mysql_query($s);
			if ($response) {
			} else {
				$e[] = mysql_error()."<br />".$s;
			}
			
			// ------------------------------------------------------------
			// templates
			$s = "INSERT INTO templates (TemplateFile, TemplateName) VALUES ('default/default.php', 'Default Template')";
			$response = mysql_query($s);
			if ($response) {
				$TemplateID["default"] = mysql_insert_id();
			} else {
				$e[] = mysql_error()."<br />".$s;
			}
			
			$s = "INSERT INTO templates (TemplateFile, TemplateName) VALUES ('joes_java/template.php', 'Joe\'s Java')";
			$response = mysql_query($s);
			if ($response) {
				$TemplateID["joes_java"] = mysql_insert_id();
			} else {
				$e[] = mysql_error()."<br />".$s;
			}
			
			// ------------------------------------------------------------
			// pages
			$RootPageTitle = "simple cms installed successfully";
			ob_start();
			?>
			<h1><?PHP echo $RootPageTitle;?></h1>
			<p><b>Contratulations!</b> You've successfully installed the <b>simple</b> content management system on your server.  You're
			now ready to create a new website. To start, go to the cms login page:</p>
			<ul>
				<li><a href="/simple_cms/login.php">login to <b>simple</b></a> Default: (username: webmaster; password: default) 
				<span style="color:#F00;">Be sure to change your password as soon as possible!</span></li>
			</ul>
			<p>In order to ensure the security of your site, your first activities should be:</p>
			<ul>
				<li>Login to the webmaster account and change the password.</li>
				<li>Create an account for you to use that reflects your name so that you're not always logging in with the generic webmaster account.</li>
				<li>Add your new accout to the webmasters group.</li>
				<li>Remove write access for the "include" folder so that nobody can alter your settings file.</li>
				<li>Double check to make sure the "tmp," "pages," and "images/simple" folders are writable.</li>
				<li>Remove the "install.php" and "install.sql" files from the root of the website.</li>
			</ul>
			<p>If you're new to the cms and need to find out what to do next, you can use the links below to get some helpful information:</p>
			<ul>
				<li><a href="http://mpierce.pie2k.com/pages/142.php"><b>simple</b> help</a> - an overview of the features and terminology
				used in <b>simple</b> as well as the variables and functions available to you when creating templates</li>
				<li><a href="http://mpierce.pie2k.com/pages/141.php"><b>simple</b> tutorials</a> - when just knowing the names of the functions
				isn't enough, the tutorials will show you step-by-step how to perform some common website tasks using the <b>simple</b> functions
				and interface</li>
			</ul>
			<p>I wish you the best of luck, and hope you have an enjoyable experience using the <b>simple</b> cms.</p>
			<p style="margin-left: 50%;"><i>Matt Pierce<br />
				author of the <b>simple</b> cms</i></p>
			<?PHP
			$RootPageBody = ob_get_contents();
			ob_end_clean();
			
			$fields = null;
			$values = null;
			
			$fields[] = "PageTitle";
			$values[] = "'".fix_apos($RootPageTitle)."'";
			$fields[] = "PageTemplateID";
			$values[] = $TemplateID["default"];
			$fields[] = "PageModifiedBy";
			$values[] = $UserID["webmaster"];
			$fields[] = "PageModifiedOn";
			$values[] = "'".date("Y-m-d H:i:s")."'";
			$fields[] = "PageCreatedBy";
			$values[] = $UserID["webmaster"];
			$fields[] = "PageCreatedOn";
			$values[] = "'".date("Y-m-d H:i:s")."'";
			$fields[] = "PageGuestView";
			$values[] = 1;
			$fields[] = "PageMenuOrder";
			$values[] = 99;
			$fields[] = "PageMenuTitle";
			$values[] = "'".fix_apos($RootPageTitle)."'";
			$fields[] = "PageBody";
			$values[] = "'".fix_apos($RootPageBody)."'";
			$fields[] = "PageFileName";
			$values[] = "'simplecmsinstalledsuccessfully'";
			
			$fields = implode(", ", $fields);
			$values = implode(", ", $values);
			
			$s = "INSERT INTO pages ($fields) VALUES ($values)";
			$response = mysql_query($s);
			if ($response) {
				$RootPageID = mysql_insert_id();
			} else {
				$e[] = mysql_error()."<br />".$s;
			}
			
			if (!RenderPage($RootPageID)) {
				$e[] = "Error rendering home page.";
			}
		}
	}
	if ($e != null) {
		$PageName = "Database Error";
		ob_start();
		echo ("<p>There were errors while trying to set up the MySQL database using the following credentials:</p>\n");
		echo ("<ul>\n");
		echo ("<li>Server: $MYSQL_Server</li>\n");
		echo ("<li>Schema: $MYSQL_DBName</li>\n");
		echo ("<li>User: $MYSQL_AdminUserName</li>\n");
		echo ("<li>Password: <i>not displayed</i></li>\n");
		echo ("</ul>\n");
		echo ("<h2>Errors</h2>\n");
		echo ("<ul>\n");
		foreach($e as $error) {
			echo ("<li>$error</li>\n");
		}
		echo ("</ul>\n");
		echo ("<p>Please check your settings and <a href=\"install.php\">try again</a>.</p>\n");
		$PageContent = ob_get_contents();
		ob_end_clean();
	} else {
		header("Location: /pages/".$RootPageID.".php");
	}
}else if ($pSubmit && $pSubmit=="Install") {

	// correct any blank entries we can
	if (!$pMaxRevisions) $pMaxRevisions = 10;
	if (!$pPasswordHash) $pPasswordHash = "The quick brown fox jumped over the lazy dog.";
	if (!$pDefaultEditMode) $pDefaultEditMode = "Xinha";
	if (!($pLDAP_host && trim($pLDAP_host)!="") ||
		!($pLDAP_search_dn && trim($pLDAP_search_dn)!="") ||
		!($pLDAP_search_pattern && trim($pLDAP_search_pattern)!="") ||
		!($pLDAP_port && is_numeric($pLDAP_port))) {
		$UseLDAP = false;
	} else {
		$UseLDAP = true;
	}
	// collect settings from form, start making settings array
	$SettingsArray = null;
	$SettingsArray[] = "<"."?PHP";
	$SettingsArray[] = "/* *****************************************";
	$SettingsArray[] = "    simple settings file";
	$SettingsArray[] = "    configured by install.php";
	$SettingsArray[] = "    ".date("Y-m-d H:i:s");
	$SettingsArray[] = "   ***************************************** */";
	$SettingsArray[] = "";
	$SettingsArray[] = "// Site Settings";
	$SettingsArray[] = "\$Site_URL=\"".eq($pSite_URL)."\";";
	$SettingsArray[] = "\$MaxRevisions=".intval($pMaxRevisions).";";
	$SettingsArray[] = "\$DefaultEditMode=\"".eq($pDefaultEditMode)."\";";
	$SettingsArray[] = "\$PasswordHash=\"".eq($pPasswordHash)."\";";
	$SettingsArray[] = "";
	$SettingsArray[] = "// MySQL Settings";
	$SettingsArray[] = "\$MYSQL_Server=\"".eq($pMYSQL_Server)."\";";
	$SettingsArray[] = "\$MYSQL_DBName=\"".eq($pMYSQL_DBName)."\";";
	$SettingsArray[] = "\$MYSQL_UserName=\"".eq($pMYSQL_UserName)."\";";
	$SettingsArray[] = "\$MYSQL_Password=\"".eq($pMYSQL_Password)."\";";
	$SettingsArray[] = "\$MYSQL_AdminUserName=\"".eq($pMYSQL_UserName)."\";";
	$SettingsArray[] = "\$MYSQL_AdminPassword=\"".eq($pMYSQL_Password)."\";";
	if ($UseLDAP) {
		$SettingsArray[] = "";
		$SettingsArray[] = "// LDAP Settings";
		$SettingsArray[] = "\$LDAP_host=\"".eq($pLDAP_host)."\";";
		$SettingsArray[] = "\$LDAP_search_dn=\"".eq($pLDAP_search_dn)."\";";
		$SettingsArray[] = "\$LDAP_port=".intval($pLDAP_port).";";
		$SettingsArray[] = "\$LDAP_search_pattern=\"".eq($pLDAP_search_pattern)."\";";
		if ((isset($pLDAP_bind_dn) && trim($pLDAP_bind_dn)!="") && 
			(isset($pLDAP_bind_pw) && trim($pLDAP_bind_pw)!="")) {
			$SettingsArray[] = "\$LDAP_bind_dn=\"".eq($pLDAP_bind_dn)."\";";
			$SettingsArray[] = "\$LDAP_bind_pw=\"".eq($pLDAP_bind_pw)."\";";
		}
	}
	$SettingsArray[] = "";
	$SettingsArray[] = "// Aliasing Settings";
	$SettingsArray[] = "\$Handle404Aliasing = ".($pHandle404Aliasing=="true"?"true":"false").";";
	$SettingsArray[] = "\$MaintainAliasList = ".($pMaintainAliasList=="true"?"true":"false").";";
	$SettingsArray[] = "\$UseAliasesInLinks = ".($pUseAliasesInLinks=="true"?"true":"false").";";
	$SettingsArray[] = "?".">";
	
	// output settings to file
	$data = implode("\n", $SettingsArray);
	$BytesWritten = @file_put_contents("./include/settings.php", $data);
	
	
	if ($BytesWritten === FALSE) {
		// report error message
		$PageName = "error in setup";
		ob_start();
		?>
		<p>The <b>simple</b> installer was unable to write your settings to a file.  Please make sure that
		the web server process is allowed to write to the folder named "include" that came in the <b>simple</b>
		zip file.</p>
		<p>After you've made the change, please <a href="install.php">start the install process again</a>.</p>
		<?PHP
		$PageContent = ob_get_contents();
		ob_end_clean();
	} else {
		// redirect here to do the sql setup
		header("Location: install.php?DoSQLSetup=true");
	}
} else {
	$PageTitle = "Install simple";
	
	ob_start();
	?>
	<p>Thank you for downloading the <b>simple</b> content management system.  Before you get started with the installer, there are
	a few things you'll have to configure on your server.  By now you should have copied all the files you downloaded into the root
	folder of the site you're creating.  If not, take a moment to do that now.</p>
	<p><b>Simple</b> uses the disk to cache pages and images.  You'll have to change permissions on the following folders in order
	to have the site function properly:</p>
	<ul>
		<li><b>/include/</b> - The installer needs access to write to this directory in order to save your site configuration.</li>
		<li><b>/images/simple/</b> and <b>/images/simple/thumbnails/</b> - Images uploaded by end-users will be stored in these locations</li>
		<li><b>/pages/</b> - Pages are rendered and cached in this folder to speed up serving, and to allow users to write PHP into their pages</li>
		<li><b>/tmp/</b> - This area is used to generate page previews from drafts</li>
		<li><b>/simple_cms/simple_rewrite.map</b> - This file holds a cache of aliases for Apache's rewrite module</li>
	</ul>
	<p>You'll also need to create a schema in your MySQL database to store the CMS information, and provide a username/password combination
	below that has the ability to SELECT, INSERT, UPDATE, and DELETE from that schema.</p>
	<form action="install.php" method="POST">
		<fieldset>
			<legend>Site Information</legend>
			<p>
				Site URL <i>(example: http://www.website.com)</i><br />
				<input type="text" id="Site_URL" name="Site_URL" value="http://<?PHP echo $_SERVER["HTTP_HOST"];?>/" style="width: 100%"/>
			</p>
			<p>
				Maximum Number of Revisions to Store<br />
				<input type="text" id="MaxRevisions" name="MaxRevisions" value="10" style="width: 100%"/>
			</p>
			<p>
				Default Edit Mode<br />
				<select name="DefaultEditMode" id="DefaultEditMode" style="width: 100%">
					<option value="xinha" selected>WYSIWYG (visual editor)</option>
					<option value="html">Source Code</option>
				</select>
			</p>
			<p>
				Password Salt <i>(a random set of words or letters used to improve password encryption)</i><br />
				<input type="text" id="PasswordHash" name="PasswordHash" value="The quick brown fox jumped over the lazy dog." style="width: 100%" />
			</p>
		</fieldset>
		<fieldset>
			<legend>MySQL Settings</legend>
			<p>
				Server<br />
				<input type="text" id="MYSQL_Server" name="MYSQL_Server" value="" style="width: 100%" />
			</p>
			<p>
				Schema Name<br />
				<input type="text" id="MYSQL_DBName" name="MYSQL_DBName" value="" style="width: 100%" />
			</p>
			<p>
				User<br />
				<input type="text" id="MYSQL_UserName" name="MYSQL_UserName" value="" style="width: 100%" />
			</p>
			<p>
				Password<br />
				<input type="password" id="MYSQL_Password" name="MYSQL_Password" value="" style="width: 100%" />
			</p>
		</fieldset>
		<fieldset>
			<legend>LDAP Settings</legend>
			<p>Fill out the following information if you want to use LDAP to authenticate usernames and passwords.</p>
			<p>
				Host<br />
				<input type="text" id="LDAP_host" name="LDAP_host" value="" style="width: 100%" />
			</p>
			<p>
				Search Base DN<br />
				<input type="text" id="LDAP_search_dn" name="LDAP_search_dn" value="" style="width: 100%" />
			</p>
			<p>
				Port (standard: 389; secure: 636)<br />
				<input type="text" id="LDAP_port" name="LDAP_port" value="" style="width: 100%" />
			</p>
			<p>
				Search Pattern - describe how <b>simple</b> should use the username to search for a DN in the directory. ex:
				<b>(&amp; (uid=[SIMPLE_USERNAME]) (status=active))</b><br />
				<input type="text" id="LDAP_search_pattern" name="LDAP_search_pattern" value="" style="width: 100%" />
			</p>
			<p>The following DN and password are only necessary if your LDAP server doesn't allow for an anonymous search.</p>
			<p>
				Bind DN<br />
				<input type="text" id="LDAP_bind_dn" name="LDAP_bind_dn" value="" style="width: 100%" />
			</p>
			<p>
				Bind Password<br />
				<input type="password" id="LDAP_bind_pw" name="LDAP_bind_pw" value="" style="width: 100%" />
			</p>
		</fieldset>
		<fieldset>
			<legend>Aliasing Settings</legend>
			<p><label><input type="checkbox" id="Handle404Aliasing" name="Handle404Aliasing" value="true" />
				Handle Aliasing Through "404 File Not Found" Page</label></p>
			<p><label><input type="checkbox" id="MaintainAliasList" name="MaintainAliasList" value="true" />
				Maintain a List of Aliases in /simple_cms/simple_rewrite.map For Use With Apache Rewrite Module</label></p>
			<p><label><input type="checkbox" id="UseAliasesInLinks" name="UseAliasesInLinks" value="true" />
				Use Aliases Instead of Page Numbers When Making Links</label> (note: only use this option if you have configured one of two
				previously mentioned methods for URL aliasing.  For more information see <a href="http://mpierce.pie2k.com/pages/218.php">http://mpierce.pie2k.com/pages/218.php</a>.
			</p>
		</fieldset>
		<p>
			<input type="submit" name="Submit" id="Submit" value="Install" />
		</p>
	</form>	
	<?PHP
	$PageContent = ob_get_contents();
	ob_end_clean();	
}
?><!DOCTYPE html>
<html>
	<head>
		<title><?PHP echo $PageTitle;?></title>
		<style type="text/css">
body {
font-size: 10pt;
font-family: Segoe UI,Verdna, sans-serif;
margin: 0px;
padding: 0px;
background-color: #777;
}

#Header {
overflow: hidden;
width: 800px;
margin-left: auto;
margin-right: auto;
color: #EEE;
letter-spacing: 0.75em;
margin-top: 20px;
margin-bottom: 20px;
}

h1 {
font-weight: normal;
text-transform: lowercase;
}

#Content {
width: 760px;
margin-left: auto;
margin-right: auto;
background-color: #FFF;
border: 4px solid #444;
padding: 20px;
}

#Footer {
margin-top: 20px;
margin-bottom: 20px;
text-align: center;
text-transform: lowercase;
color: #EEE;
}

#Content fieldset {
background-color: #EEE;
}

		</style>
	</head>
	<body>
		<div id="PageContainer">
			<div id="Header">
				<h1>Simple version 1.4</h1>
			</div>
			<div id="Content">
				<h1><?PHP echo $PageTitle;?></h1>
				<?PHP echo $PageContent;?>
			</div>
			<div id="Footer">
				&copy;<?PHP echo date("Y");?> Matt Pierce
			</div>
		</div>
	</body>
</html>