<?PHP
/* ****************************************************
   simple cms
   by: Matt Pierce - 2009
   
   /simple_cms/folder_user_permissions.php
   
   Allows a user to set user permissions for an image folder.
   The user must have the $P_MANAGE permission bit set.
   **************************************************** */
include_once("../include/global.php");
session_start();
if (!session_is_registered('username')) {
	header("Location: login.php?RedirectTo=".basename($PHP_SELF));
} else {
	$username = $_SESSION['username'];
}

db_connect_a($MYSQL_DBName);
$UserResponse = mysql_query("SELECT * FROM users WHERE UserName='$username'");
$UserObj = mysql_fetch_object($UserResponse);
$UserID = $UserObj->UserID;

import_request_variables("p", "p");
import_request_variables("g", "g");
$AdminTitle = "folder group permissions";
$AdminHeaderContent = "";
$AdminContent = "";
$AdminSection = "images";

ob_start();

db_connect($MYSQL_DBName);

$GroupList = GetGroups($UserObj->UserID);

if ($gAction && $gAction=="MoveRight") {
	// get the editor's permissions
	$gFolderID = intval($gFolderID);
	$FolderPermissions = GetImageFolderPermissionsRecursive($gFolderID, $UserObj->UserID, $GroupList);
	if ($FolderPermissions & $P_MANAGE) {
		// get perms for target group
		$gGroupID = intval($gGroupID);
		$TargetFolderPermissions = GetImageFolderGroupPermissionsRecursive($gFolderID, $gGroupID);
		// create an entry in the perms table for this user/folder
		mysql_query("DELETE FROM imagefoldergrouppermissions WHERE GroupID=$gGroupID AND FolderID=$gFolderID");
		mysql_query("INSERT INTO imagefoldergrouppermissions (GroupID, FolderID, Permissions) VALUES ($gGroupID, $gFolderID, $TargetFolderPermissions)");
	}
} else if ($gAction && $gAction=="MoveLeft") {
	// get the editor's permissions
	$gFolderID = intval($gFolderID);
	$FolderPermissions = GetImageFolderPermissionsRecursive($gFolderID, $UserObj->UserID, $GroupList);
	if ($FolderPermissions & $P_MANAGE) {
		$gGroupID = intval($gGroupID);
		mysql_query("DELETE FROM imagefoldergrouppermissions WHERE GroupID=$gGroupID AND FolderID=$gFolderID");
	}
} else if ($pSubmit && $pSubmit=="Update") {
	$pFolderID = intval($pFolderID);
	$FolderPermissions = GetImageFolderPermissionsRecursive($pFolderID, $UserID, $GroupList);
	if ($FolderPermissions & $P_MANAGE) {
		$Perms = 0;
		if (isset($pPermView) && $pPermView=="Y") $Perms = $Perms | $P_VIEW;
		if (isset($pPermEdit) && $pPermEdit=="Y") $Perms = $Perms | $P_EDIT;
		if (isset($pPermCreate) && $pPermCreate=="Y") $Perms = $Perms | $P_CREATE;
		if (isset($pPermDelete) && $pPermDelete=="Y") $Perms = $Perms | $P_DELETE;
		if (isset($pPermManage) && $pPermManage=="Y") $Perms = $Perms | $P_MANAGE;
		$pGroupID = intval($pGroupID);
		mysql_query("DELETE FROM imagefoldergrouppermissions WHERE GroupID=$pGroupID AND FolderID=$pFolderID");
		mysql_query("INSERT INTO imagefoldergrouppermissions (GroupID, FolderID, Permissions) VALUES ($pGroupID, $pFolderID, $Perms)");
	}
	$gFolderID = $pFolderID;
	$gGroupID = $pGroupID;
	if (isset($gAction)) unset($gAction);
}

if (UserIsAdmin($UserObj->UserID) || ($UserObj->UserPermissions & $P_IMAGES)) {

	$FolderResponse = mysql_query("SELECT * FROM imagefolders WHERE FolderID=".$gFolderID);
	if ($FolderResponse && mysql_num_rows($FolderResponse)>0) {
		
		$FolderObj = mysql_fetch_object($FolderResponse);
		echo ("<p><a href=\"tab_images.php".($FolderObj->FolderParentID?"?CurrentFolder=".$FolderObj->FolderParentID:"")."\">Return to Image Folders</a></p>\n");
		
		$FolderPermissions = GetImageFolderPermissionsRecursive($gFolderID, $UserObj->UserID, $GroupList);
		if ($FolderPermissions & $P_MANAGE) {
		
			echo ("<div style=\"width:auto; overflow: hidden; border: 1px solid #000;\">\n");
			
			// users without permissions set
			echo ("<div style=\"float: left; width: 33%;\">\n");
			echo ("<h2>Inherit Permissions:</h2>\n");
			$GroupResponse = mysql_query("SELECT DISTINCT groups.GroupID, GroupName FROM groups, imagefoldergrouppermissions AS ifgp WHERE groups.GroupID=ifgp.GroupID AND FolderID=$gFolderID ORDER BY GroupName");
			while ($tGroupObj = mysql_fetch_object($GroupResponse)) {
				$tGroupList[] = $tGroupObj->GroupID;
			}
			if ($tGroupList) {
				$GroupResponse = mysql_query("SELECT * FROM groups WHERE NOT FIND_IN_SET(GroupID, '".implode(",",$tGroupList)."') ORDER BY GroupName");
			} else {
				$GroupResponse = mysql_query("SELECT * FROM groups ORDER BY GroupName");
			}
			while ($tGroupObj = mysql_fetch_object($GroupResponse)) {
				echo("<a href=\"folder_group_permissions.php?GroupID=$tGroupObj->GroupID&FolderID=$gFolderID\">$tGroupObj->GroupName</a> -- ");
				echo("<a href=\"folder_group_permissions.php?Action=MoveRight&FolderID=$gFolderID&GroupID=$tGroupObj->GroupID\">&gt;&gt;</a><br />\n");
			}
			echo ("</div>\n");
			
			// users with permissions set
			echo ("<div style=\"float: left; width: 33%;\">\n");
			echo ("<h2>Inherit Permissions:</h2>\n");
			$GroupResponse = mysql_query("SELECT DISTINCT groups.GroupID, GroupName FROM groups, imagefoldergrouppermissions AS ifgp WHERE groups.GroupID=ifgp.GroupID AND FolderID=$gFolderID ORDER BY GroupName");
			while ($tGroupObj = mysql_fetch_object($GroupResponse)) {
				echo("<a href=\"folder_group_permissions.php?Action=MoveLeft&FolderID=$gFolderID&GroupID=$tGroupObj->GroupID\">&lt;&lt;</a>");
				echo(" -- <a href=\"folder_group_permissions.php?GroupID=$tGroupObj->GroupID&FolderID=$gFolderID\">$tGroupObj->GroupName</a><br/>\n");
			}
			echo ("</div>\n");
			
			
			// edit/view user's permissions
			echo ("<div style=\"float: left; width: 33%;\">\n");
			if ($gGroupID) {
				$gGroupID = intval($gGroupID);
				$tGroupResponse = mysql_query("SELECT * FROM groups WHERE GroupID=$gGroupID");
				if ($tGroupResponse && mysql_num_rows($tGroupResponse)>0) {
					$tGroupObj = mysql_fetch_object($tGroupResponse);
					$tPermResponse = mysql_query("SELECT * FROM imagefoldergrouppermissions WHERE GroupID=$gGroupID AND FolderID=$gFolderID");
					if ($tPermResponse && mysql_num_rows($tPermResponse)>0) {
						echo ("<h2>Folder Permissions:</h2>\n");
						echo ("<p><b>".$tGroupObj->GroupName."</b></p>\n");
						echo ("<form action=\"folder_group_permissions.php\" method=\"POST\">\n");
						$tPerm = mysql_fetch_object($tPermResponse);
						echo ("<input type=\"hidden\" id=\"FolderID\" name=\"FolderID\" value=\"".$tPerm->FolderID."\" />\n");
						echo ("<input type=\"hidden\" id=\"GroupID\" name=\"GroupID\" value=\"".$tGroupObj->GroupID."\" />\n");
?>
<p>
<label><input type="checkbox" value="Y" name="PermView" id="PermView" <?PHP if ($tPerm->Permissions & $P_VIEW) echo "checked";?> />View</label><br />
<label><input type="checkbox" value="Y" name="PermEdit" id="PermEdit" <?PHP if ($tPerm->Permissions & $P_EDIT) echo "checked";?> />Edit</label><br />
<label><input type="checkbox" value="Y" name="PermCreate" id="PermCreate" <?PHP if ($tPerm->Permissions & $P_CREATE) echo "checked";?> />Create</label><br />
<label><input type="checkbox" value="Y" name="PermDelete" id="PermDelete" <?PHP if ($tPerm->Permissions & $P_DELETE) echo "checked";?> />Delete</label><br />
<label><input type="checkbox" value="Y" name="PermManage" id="PermManage" <?PHP if ($tPerm->Permissions & $P_MANAGE) echo "checked";?> />Manage</label><br />
<?PHP if ($tUserObj->UserIsAdmin == "Y") echo ("Administrator<br>\n");?>
</p>
<p>
<input type="Submit" name="Submit" id="Submit" value="Update" />
</p>
<?PHP
						echo ("</form>\n");
					} else {
						echo ("<h2>Inherited Permissions:</h2>\n");
						echo ("<p><b>".$tGroupObj->GroupName."</b></p>\n");
						$Permissions = GetImageFolderGroupPermissionsRecursive($gFolderID, $tGroupObj->GroupID);
						echo ("<p>\n");
						if (($Permissions & $P_VIEW)>0) echo ("View<br>\n");
						if (($Permissions & $P_EDIT)>0) echo ("Edit<br>\n");
						if (($Permissions & $P_CREATE)>0) echo ("Create<br>\n");
						if (($Permissions & $P_DELETE)>0) echo ("Delete<br>\n");
						if (($Permissions & $P_MANAGE)>0) echo ("Manage<br>\n");
						if ($tGroupObj->GroupIsAdmin == "Y") echo ("Administrator<br>\n");
						echo ("</p>\n");
					}
				} else {
					echo ("<p>ERROR: Unable to locate the selected group.</p>\n");
				}
			}
			echo ("</div>\n");
			
			
			echo ("</div>\n");
		} else {
			echo ("<p>ERROR: You do not have sufficient permissions to manage this folder.</p>\n");
		}
	} else {
		echo ("<p>ERROR: The specified folder does not exist.</p>\n");
	}
} else {
	echo ("<p>ERROR: You do not have permission to manage images.</p>\n");
}


$AdminContent = ob_get_contents();
ob_end_clean();
include("admin_template.php");
?>