<?PHP
/* ****************************************************
   simple cms
   by: Matt Pierce - 2009
   
   /simple_cms/folder_user_permissions.php
   
   Allows a user to set user permissions for an image folder.
   The user must have the $P_MANAGE permission bit set.
   **************************************************** */
include_once("../include/global.php");
session_start();
if (!session_is_registered('username')) {
	header("Location: login.php?RedirectTo=".basename($PHP_SELF));
} else {
	$username = $_SESSION['username'];
}

db_connect_a($MYSQL_DBName);
$UserResponse = mysql_query("SELECT * FROM users WHERE UserName='$username'");
$UserObj = mysql_fetch_object($UserResponse);
$UserID = $UserObj->UserID;

import_request_variables("p", "p");
import_request_variables("g", "g");
$AdminTitle = "folder user permissions";
$AdminHeaderContent = "";
$AdminContent = "";
$AdminSection = "images";

ob_start();

db_connect($MYSQL_DBName);

$GroupList = GetGroups($UserObj->UserID);

if ($gAction && $gAction=="MoveRight") {
	// get the editor's permissions
	$gFolderID = intval($gFolderID);
	$FolderPermissions = GetImageFolderPermissionsRecursive($gFolderID, $UserObj->UserID, $GroupList);
	if ($FolderPermissions & $P_MANAGE) {
		// get perms for target user
		$gUserID = intval($gUserID);
		$TargetFolderPermissions = GetImageFolderPermissionsRecursive($gFolderID, $gUserID, GetGroups($gUserID));
		// create an entry in the perms table for this user/folder
		mysql_query("DELETE FROM imagefolderuserpermissions WHERE UserID=$gUserID AND FolderID=$gFolderID");
		mysql_query("INSERT INTO imagefolderuserpermissions (UserID, FolderID, Permissions) VALUES ($gUserID, $gFolderID, $TargetFolderPermissions)");
	}
} else if ($gAction && $gAction=="MoveLeft") {
	// get the editor's permissions
	$gFolderID = intval($gFolderID);
	$FolderPermissions = GetImageFolderPermissionsRecursive($gFolderID, $UserObj->UserID, $GroupList);
	if ($FolderPermissions & $P_MANAGE) {
		mysql_query("DELETE FROM imagefolderuserpermissions WHERE UserID=$gUserID AND FolderID=$gFolderID");
	}
} else if ($pSubmit && $pSubmit=="Update") {
	$pFolderID = intval($pFolderID);
	$FolderPermissions = GetImageFolderPermissionsRecursive($pFolderID, $UserID, $GroupList);
	if ($FolderPermissions & $P_MANAGE) {
		$Perms = 0;
		if (isset($pPermView) && $pPermView=="Y") $Perms = $Perms | $P_VIEW;
		if (isset($pPermEdit) && $pPermEdit=="Y") $Perms = $Perms | $P_EDIT;
		if (isset($pPermCreate) && $pPermCreate=="Y") $Perms = $Perms | $P_CREATE;
		if (isset($pPermDelete) && $pPermDelete=="Y") $Perms = $Perms | $P_DELETE;
		if (isset($pPermManage) && $pPermManage=="Y") $Perms = $Perms | $P_MANAGE;
		mysql_query("DELETE FROM imagefolderuserpermissions WHERE UserID=$pUserID AND FolderID=$pFolderID");
		mysql_query("INSERT INTO imagefolderuserpermissions (UserID, FolderID, Permissions) VALUES ($pUserID, $pFolderID, $Perms)");
	}
	$gFolderID = $pFolderID;
	$gUserID = $pUserID;
	if (isset($gAction)) unset($gAction);
}

if (UserIsAdmin($UserObj->UserID) || ($UserObj->UserPermissions & $P_IMAGES)) {

	$FolderResponse = mysql_query("SELECT * FROM imagefolders WHERE FolderID=".$gFolderID);
	if ($FolderResponse && mysql_num_rows($FolderResponse)>0) {
		
		$FolderObj = mysql_fetch_object($FolderResponse);
		echo ("<p><a href=\"tab_images.php".($FolderObj->FolderParentID?"?CurrentFolder=".$FolderObj->FolderParentID:"")."\">Return to Image Folders</a></p>\n");
		
		$FolderPermissions = GetImageFolderPermissionsRecursive($gFolderID, $UserObj->UserID, $GroupList);
		if ($FolderPermissions & $P_MANAGE) {
		
			echo ("<div style=\"width:auto; overflow: hidden; border: 1px solid #000;\">\n");
			
			// users without permissions set
			echo ("<div style=\"float: left; width: 33%;\">\n");
			echo ("<h2>Inherit Permissions:</h2>\n");
			$UserResponse = mysql_query("SELECT DISTINCT users.UserID, UserName, UserFullName FROM users, imagefolderuserpermissions AS ifup WHERE users.UserID = ifup.UserID AND FolderID=$gFolderID ORDER BY UserName");
			while ($tUserObj = mysql_fetch_object($UserResponse)) {
				$UserList[] = $tUserObj->UserID;
			}
			if ($UserList) {
				$UserResponse = mysql_query("SELECT * FROM users WHERE NOT FIND_IN_SET(UserID, '".implode(",", $UserList)."') ORDER BY UserName");
			} else {
				$UserResponse = mysql_query("SELECT * FROM users ORDER BY UserName");
			}
			while ($tUserObj = mysql_fetch_object($UserResponse)) {
				echo("<a href=\"folder_user_permissions.php?UserID=$tUserObj->UserID&FolderID=$gFolderID\">$tUserObj->UserName ($tUserObj->UserFullName)</a> -- <a href=\"folder_user_permissions.php?Action=MoveRight&FolderID=$gFolderID&UserID=$tUserObj->UserID\">&gt;&gt;</a><br/>\n");
			}
			echo ("</div>\n");
			
			// users with permissions set
			echo ("<div style=\"float: left; width: 33%;\">\n");
			echo ("<h2>Inherit Permissions:</h2>\n");
			$UserResponse = mysql_query("SELECT DISTINCT users.UserID, UserName, UserFullName FROM users, imagefolderuserpermissions AS ifup WHERE users.UserID = ifup.UserID AND FolderID=$gFolderID ORDER BY UserName");
			while ($tUserObj = mysql_fetch_object($UserResponse)) {
				echo("<a href=\"folder_user_permissions.php?Action=MoveLeft&FolderID=$gFolderID&UserID=$tUserObj->UserID\">&lt;&lt;</a> -- <a href=\"folder_user_permissions.php?UserID=$tUserObj->UserID&FolderID=$gFolderID\">$tUserObj->UserName ($tUserObj->UserFullName)</a><br/>\n");
			}
			echo ("</div>\n");
			
			
			// edit/view user's permissions
			echo ("<div style=\"float: left; width: 33%;\">\n");
			if ($gUserID) {
				$gUserID = intval($gUserID);
				$tUserResponse = mysql_query("SELECT * FROM users WHERE UserID=$gUserID");
				if ($tUserResponse && mysql_num_rows($tUserResponse)>0) {
					$tUserObj = mysql_fetch_object($tUserResponse);
					$tPermResponse = mysql_query("SELECT * FROM imagefolderuserpermissions WHERE UserID=$gUserID AND FolderID=$gFolderID");
					if ($tPermResponse && mysql_num_rows($tPermResponse)>0) {
						echo ("<h2>Folder Permissions:</h2>\n");
						echo ("<p><b>".$tUserObj->UserName."(".$tUserObj->UserFullName.")</b></p>\n");
						echo ("<form action=\"folder_user_permissions.php\" method=\"POST\">\n");
						$tPerm = mysql_fetch_object($tPermResponse);
						echo ("<input type=\"hidden\" id=\"FolderID\" name=\"FolderID\" value=\"".$tPerm->FolderID."\" />\n");
						echo ("<input type=\"hidden\" id=\"UserID\" name=\"UserID\" value=\"".$tUserObj->UserID."\" />\n");
?>
<p>
<label><input type="checkbox" value="Y" name="PermView" id="PermView" <?PHP if ($tPerm->Permissions & $P_VIEW) echo "checked";?> />View</label><br />
<label><input type="checkbox" value="Y" name="PermEdit" id="PermEdit" <?PHP if ($tPerm->Permissions & $P_EDIT) echo "checked";?> />Edit</label><br />
<label><input type="checkbox" value="Y" name="PermCreate" id="PermCreate" <?PHP if ($tPerm->Permissions & $P_CREATE) echo "checked";?> />Create</label><br />
<label><input type="checkbox" value="Y" name="PermDelete" id="PermDelete" <?PHP if ($tPerm->Permissions & $P_DELETE) echo "checked";?> />Delete</label><br />
<label><input type="checkbox" value="Y" name="PermManage" id="PermManage" <?PHP if ($tPerm->Permissions & $P_MANAGE) echo "checked";?> />Manage</label><br />
<?PHP if ($tUserObj->UserIsAdmin == "Y") echo ("Administrator<br>\n");?>
</p>
<p>
<input type="Submit" name="Submit" id="Submit" value="Update" />
</p>
<?PHP
						echo ("</form>\n");
					} else {
						echo ("<h2>Inherited Permissions:</h2>\n");
						echo ("<p><b>".$tUserObj->UserName."(".$tUserObj->UserFullName.")</b></p>\n");
						$Permissions = GetImageFolderPermissionsRecursive($gFolderID, $tUserObj->UserID, GetGroups($tUserObj->UserID));
						echo ("<p>\n");
						if (($Permissions & $P_VIEW)>0) echo ("View<br>\n");
						if (($Permissions & $P_EDIT)>0) echo ("Edit<br>\n");
						if (($Permissions & $P_CREATE)>0) echo ("Create<br>\n");
						if (($Permissions & $P_DELETE)>0) echo ("Delete<br>\n");
						if (($Permissions & $P_MANAGE)>0) echo ("Manage<br>\n");
						if ($tUserObj->UserIsAdmin == "Y") echo ("Administrator<br>\n");
						echo ("</p>\n");
					}
				} else {
					echo ("<p>ERROR: Unable to locate the selected user.</p>\n");
				}
			}
			echo ("</div>\n");
			
			
			echo ("</div>\n");
		} else {
			echo ("<p>ERROR: You do not have sufficient permissions to manage this folder.</p>\n");
		}
	} else {
		echo ("<p>ERROR: The specified folder does not exist.</p>\n");
	}
} else {
	echo ("<p>ERROR: You do not have permission to manage images.</p>\n");
}


$AdminContent = ob_get_contents();
ob_end_clean();
include("admin_template.php");
?>