<?PHP
/* ****************************************************
   simple cms
   by: Matt Pierce - 2009
   
   /simple_cms/page_permissions.php
   
   Allows a user to set user permissions for a page.
   The user must have the $P_MANAGE permission bit set.
   **************************************************** */
include_once("../include/global.php");
session_start();
if (!session_is_registered('username')) {
	header("Location: login.php?RedirectTo=".basename($PHP_SELF));
} else {
	$username = $_SESSION['username'];
}

db_connect_a($MYSQL_DBName);
$UserResponse = mysql_query("SELECT * FROM users WHERE UserName='$username'");
$UserObj = mysql_fetch_object($UserResponse);
$UserID = $UserObj->UserID;

import_request_variables("p", "p");
import_request_variables("g", "g");

$AdminTitle = "page user permissions";
$AdminHeaderContent = "";
$AdminContent = "";
$AdminSection = "pages";

if ($gAction && $gAction=="MoveRight") {
	$UserPerms = GetPagePermissions($gPageID, $UserID);
	if (($UserPerms & $P_MANAGE)>0) {
		// get this user's permission for this page
		$Permissions = GetPagePermissions($gPageID, $gUserID);
		// clear out any special permissions for this user
		mysql_query("DELETE FROM pageuserpermissions WHERE PageID=$gPageID AND UserID=$gUserID");
		// insert a new set of special permissions
		mysql_query("INSERT INTO pageuserpermissions (PageID, UserID, Permissions) VALUES ($gPageID, $gUserID, $Permissions)");
		// redirect to this page
		LogWrite($UserID, "User", "Set Special Permissions for User $gUserID on Page $gPageID");
		
		// if this was the guest user, update guest view flag
		UpdateGuestView($gPageID);
	}
	header("Location: page_permissions.php?PageID=$gPageID&UserID=$gUserID");
} else if ($gAction && $gAction=="MoveLeft") {
	$UserPerms = GetPagePermissions($gPageID, $UserID);
	if (($UserPerms & $P_MANAGE)>0) {
		// clear out any special permissions for this user
		mysql_query("DELETE FROM pageuserpermissions WHERE PageID=$gPageID AND UserID=$gUserID");
		// redirect to this page
		LogWrite($UserID, "User", "Cleared Special Permissions for User $gUserID on Page $gPageID");
		// if this was the guest user, update guest view flag
		UpdateGuestView($gPageID);
	}
	header("Location: page_permissions.php?PageID=$gPageID&UserID=$gUserID");
} else if ($pUpdate && $pUpdate=="Update") {
	$UserPerms = GetPagePermissions($gPageID, $UserID);
	if (($UserPerms & $P_MANAGE)>0) {
		$Permissions = 0;
		if ($pView && $pView=="Y") $Permissions = $Permissions | $P_VIEW;
		if ($pEdit && $pEdit=="Y") $Permissions = $Permissions | $P_EDIT;
		if ($pCreate && $pCreate=="Y") $Permissions = $Permissions | $P_CREATE;
		if ($pPublish && $pPublish=="Y") $Permissions = $Permissions | $P_PUBLISH;
		if ($pDelete && $pDelete=="Y") $Permissions = $Permissions | $P_DELETE;
		if ($pManage && $pManage=="Y") $Permissions = $Permissions | $P_MANAGE;
		mysql_query("UPDATE pageuserpermissions SET Permissions=$Permissions WHERE UserID=$pUserID AND PageID=$pPageID");
		LogWrite($UserID, "User", "Altered Special Permissions for User $pUserID on Page $pPageID");
		// if this was the guest user, update guest view flag
		UpdateGuestView($pPageID);
	}
	header("Location: page_permissions.php?PageID=$pPageID&UserID=$pUserID");
} else {

ob_start();

db_connect($MYSQL_DBName);
import_request_variables("g","g");
if (!$gPageID || $gPageID=="") {
	echo ("<p>The page requested does not exist.  Please select a different page from the <a href=\"tab_pages.php\">Page Listing</a>.</p>\n");
} else {
	$PageQuery = "SELECT * FROM pages WHERE PageID=".$gPageID;
	$PageResponse = mysql_query($PageQuery);
	if (!$PageResponse || mysql_num_rows($PageResponse)==0) {
		echo ("<p>The page requested does not exist.  Please select a different page from the <a href=\"tab_pages.php\">Page Listing</a>.</p>\n");
	} else {
		$Permissions = GetPagePermissions($gPageID, $UserID);
		if (($Permissions & ($P_MANAGE))>0) {
			$PageObj = mysql_fetch_object($PageResponse);
		?><p><?PHP echo $PageObj->PageTitle;?></p>
<table width="100%"  border="1" cellspacing="0" cellpadding="4">
  <tr>
    <td width="33%"><strong>Inherit Permissions: </strong></td>
    <td width="33%"><strong>Special Permissions: </strong></td>
    <td width="34%">&nbsp;</td>
  </tr>
  <tr>
    <td valign="top"><?PHP
		// $UserResponse = mysql_query("SELECT * FROM users WHERE NOT EXISTS (SELECT * FROM pageuserpermissions WHERE PageID=$gPageID AND pageuserpermissions.UserID = users.UserID) ORDER BY UserName");
		$UserResponse = mysql_query("SELECT DISTINCT users.UserID, UserName, UserFullName FROM users, pageuserpermissions WHERE users.UserID = pageuserpermissions.UserID AND PageID=$gPageID ORDER BY UserName");
		while ($UserObj = mysql_fetch_object($UserResponse)) {
			$UserList[] = $UserObj->UserID;
		}
		if ($UserList) {
			$UserResponse = mysql_query("SELECT * FROM users WHERE NOT FIND_IN_SET(UserID, '".implode(",", $UserList)."') ORDER BY UserName");
		} else {
			$UserResponse = mysql_query("SELECT * FROM users ORDER BY UserName");
		}
		while ($UserObj = mysql_fetch_object($UserResponse)) {
			echo("<a href=\"page_permissions.php?UserID=$UserObj->UserID&PageID=$gPageID\">$UserObj->UserName ($UserObj->UserFullName)</a> -- <a href=\"page_permissions.php?Action=MoveRight&PageID=$gPageID&UserID=$UserObj->UserID\">&gt;&gt;</a><br/>\n");
		}
		
		
	?></td>
    <td valign="top"><?PHP
		// $UserResponse = mysql_query("SELECT * FROM users WHERE EXISTS (SELECT * FROM pageuserpermissions WHERE PageID=$gPageID AND pageuserpermissions.UserID = users.UserID) ORDER BY UserName");
		$UserResponse = mysql_query("SELECT DISTINCT users.UserID, UserName, UserFullName FROM users, pageuserpermissions WHERE users.UserID = pageuserpermissions.UserID AND PageID=$gPageID ORDER BY UserName");
		echo mysql_error();
		while ($UserObj = mysql_fetch_object($UserResponse)) {
			echo("<a href=\"page_permissions.php?Action=MoveLeft&PageID=$gPageID&UserID=$UserObj->UserID\">&lt;&lt;</a> -- <a href=\"page_permissions.php?UserID=$UserObj->UserID&PageID=$gPageID\">$UserObj->UserName ($UserObj->UserFullName)</a><br/>\n");
		}
		
	?></td>
    <td valign="top"><?PHP
		if ($gUserID) {
			$UserObj = mysql_fetch_object(mysql_query("SELECT * FROM users WHERE UserID=$gUserID"));
			$PermissionsResult = mysql_query("SELECT * FROM pageuserpermissions WHERE UserID=$gUserID AND PageID=$gPageID");
			if ($PermissionsResult && mysql_num_rows($PermissionsResult)>0) {
				// special permissions
				echo ("<b>$UserObj->UserName ($UserObj->UserFullName) Special Permissions</b>\n");
				$PermissionsObj = mysql_fetch_object($PermissionsResult);
				$Permissions = $PermissionsObj->Permissions;
				?>
      <form action="page_permissions.php" method="post" name="PermissionsForm" id="PermissionsForm">
        <input name="View" type="checkbox" id="View" value="Y" <?PHP if (($Permissions & $P_VIEW)>0) echo "checked"; ?>>
View <br>
<input name="Edit" type="checkbox" id="Edit" value="Y" <?PHP if (($Permissions & $P_EDIT)>0) echo "checked"; ?>> 
Edit
<br>
<input name="Create" type="checkbox" id="Create" value="Y" <?PHP if (($Permissions & $P_CREATE)>0) echo "checked"; ?>> 
Create
<br>
<input name="Publish" type="checkbox" id="Publish" value="Y" <?PHP if (($Permissions & $P_PUBLISH)>0) echo "checked"; ?>> 
Publish
<br>
<input name="Delete" type="checkbox" id="Delete" value="Y" <?PHP if (($Permissions & $P_DELETE)>0) echo "checked"; ?>> 
Delete
<br>
<input name="Manage" type="checkbox" id="Manage" value="Y" <?PHP if (($Permissions & $P_MANAGE)>0) echo "checked"; ?>> 
Manage
<br>
<input name="UserID" type="hidden" id="UserID" value="<?PHP echo $gUserID;?>">
<input name="PageID" type="hidden" id="PageID" value="<?PHP echo $gPageID;?>">
<input name="Update" type="submit" id="Update" value="Update">
                                                      </form>
				<?PHP
			} else {
				// inherited permissions
				echo ("<b>$UserObj->UserName ($UserObj->UserFullName) Inherited Permissions</b><br/>\n");
				$Permissions = GetPagePermissions($gPageID, $gUserID);
				if (($Permissions & $P_VIEW)>0) echo ("View<br>\n");
				if (($Permissions & $P_EDIT)>0) echo ("Edit<br>\n");
				if (($Permissions & $P_CREATE)>0) echo ("Create<br>\n");
				if (($Permissions & $P_PUBLISH)>0) echo ("Publish<br>\n");
				if (($Permissions & $P_DELETE)>0) echo ("Delete<br>\n");
				if (($Permissions & $P_MANAGE)>0) echo ("Manage<br>\n");
				if ($UserObj->UserIsAdmin == "Y") echo ("Administrator<br>\n");
			}
		}
	?></td>
  </tr>
</table>
	
<a href="../pages/<?PHP echo $PageObj->PageID;?>.php">Return to page</a>
	<?PHP
		} else {
			echo("ERROR: You do not have permission to edit this page.");
		}
	}
}

$AdminContent = ob_get_contents();
ob_end_clean();

include("admin_template.php");

}
?>